//-----------------------------------------------------------------------------
//  Project ced
//  OWL NExt
//  Copyright 2000. All Rights reserved.
//
//  SUBSYSTEM:    ced Application
//  FILE:         cedapp.cpp
//  AUTHOR:       Yura
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TcedAppl (TApplication).
//  (Generated by OWL 6.x Wizard for MS VC++. Version 1.5)
//-----------------------------------------------------------------------------
#include "owlpch.h"

#include <owl/buttonga.h>
#include <owl/statusba.h>
#include <owl/docmanag.h>
#include <owl/filedoc.h>
#include <owl/cmdline.h>
#include <owl/filename.h>
#include <owl/functor.h>
#include <owl/textgadg.h>
#include <owl/bitmapga.h>
#include <owl/btntextg.h>
#include <owl/template.h>
#include <owl\glyphbtn.h>
#include <owl/configfl.h>

#include <coolprj/clrpropdlg.h>
#include <coolprj/cooledit.rh>  // Definition of about dialog.
#include <owl\propsht.rh>
#include "cedapp.h"

#include "cedcl.h" // Definition of client class.
#include "cedmdich.h" // Definition of child class.
//#include <owl/editview.h> // Definition of view class.
#include "cedab.h"  // Definition of about dialog.





//
// Generated help file.
//
const _TCHAR HelpFileName[] = _T("ced.hlp");
static LPCTSTR GetAppRegPath()
{
  static _TCHAR* regPath = _T("OWL NExt\\Ced");
  return regPath;
}

//{{TCoolEditAppl Implementation}}

//
// Build a response table for all messages/commands handled by the application.
//
DEFINE_RESPONSE_TABLE2(TCoolEditAppl, TRecentFiles, TApplication)
//{{TCoolEditApplRSP_TBL_BEGIN}}
  EV_OWLVIEW(dnCreate,      EvNewView),
  EV_OWLVIEW(dnClose,       EvCloseView),
  EV_COMMAND(CM_FILESEND,     CmFileSend),
  EV_COMMAND_ENABLE(CM_FILESEND, CeFileSend),
  EV_COMMAND(CM_HELPABOUT,    CmHelpAbout),
  EV_COMMAND(CM_HELPCONTENTS,   CmHelpContents),
  EV_COMMAND(CM_HELPUSING,    CmHelpUsing),
  EV_WM_DROPFILES,
  EV_WM_WININICHANGE,
  EV_OWLDOCUMENT(dnCreate,    EvOwlDocument),
  EV_OWLDOCUMENT(dnRename,    EvOwlDocument),
  EV_REGISTERED(MruFileMessage,  CmFileSelected),
  EV_COMMAND(CM_OPTIONS_PREF,     CmOptionsPref),
//{{TCoolEditApplRSP_TBL_END}}
END_RESPONSE_TABLE;

//--------------------------------------------------------
// TCoolEditAppl
// ~~~~~
//
TCoolEditAppl::TCoolEditAppl()
:
  TApplication(_T("CoolEdit")),
  TRecentFiles(_T("Software\\OWL NExt\\CED"), 4, 30, true)
{
  HelpState = false;
  ContextHelp = false;
  HelpCursor = 0;
  Printer = 0;
  Printing = 0;

  SetDocManager(new TDocManager(dmMDI, this));

  TRY{
    ApxMail = new TMailer();
  }
  CATCH((...){
    ApxMail = 0;
  })

  // INSERT>> Your constructor code here.
}
//-----------------------------------------------------------------------------
TCoolEditAppl::~TCoolEditAppl()
{
  delete Printer;
  delete ApxMail;
}
//-----------------------------------------------------------------------------
bool TCoolEditAppl::CanClose()
{
  bool result = TApplication::CanClose();

  // Close the help engine if we used it.
  //
  if (result && HelpState)
    GetMainWindow()->WinHelp(HelpFileName, HELP_QUIT, 0);
  return result;
}

//-------------------------------------------------------
// This is default implementaion of GadgetBuilder.
// You can delete this function and use default GadgetBuilder
// if you do not plan to castomize creation of gadgets.
//
TGadget* UserGadgetBuilder(int index, int cmdId, bool& usecell)
{
  usecell = false;
  if(cmdId==0)
    return new TSeparatorGadget;
  usecell = true;
  return new TButtonTextGadget(cmdId,
                               index,
                               TButtonTextGadget::sBitmap,
                               TButtonTextGadget::Command,
                               false,
                               TButtonTextGadget::Up,
                               true);
}

//------------------------------------------------------------
// If you do not want customize Dockable bar creation you can
// delete next function.
//
static TGadgetWindow* UserBarCreator(TWindow* frame)
{
  TDockableControlBar* cb = new TDockableControlBar(frame);

  // Add caption and fly-over help hints.
  //
  cb->SetCaption(_T("Toolbar"));
  cb->SetHintMode(TGadgetWindow::EnterHints);
  return cb;
}

bool TCoolEditAppl::UserBarInserter(TDecoratedFrame&, TGadgetWindow& destWindow, TAbsLocation loc)
{
  if(ApxHarbor->GetHandle())
    destWindow.Create();
  ApxHarbor->Insert((TDockableControlBar&)destWindow, loc);
  return true;
}

void TCoolEditAppl::SetupSpeedBar(TDecoratedMDIFrame* frame)
{
  ApxHarbor = new THarbor(*frame);

  TBarDescr* barDescr = new TBarDescr(IDM_MDI);

  // You can delete this line and use default GadgetBuilder
  // if you do not plan to castomize gadgets
  barDescr->SetBuilder(TGadget_FUNCTOR(UserGadgetBuilder));

  frame->SetBarDescr(barDescr);

  // If you do not want customize Dockable bar creation you can
  // delete next line : frame->SetBarCreator(...)
  frame->SetBarCreator(TGadgetWnd_FUNCTOR(UserBarCreator));
  frame->SetBarInserter(TBarInsert_MFUNCTOR(*this,&TCoolEditAppl::UserBarInserter));
}

//--------------------------------------------------------
// TCoolEditAppl
// ~~~~~
// Application main window construction & intialization.
//
void TCoolEditAppl::InitMainWindow()
{
  if (nCmdShow != SW_HIDE)
    nCmdShow = (nCmdShow != SW_SHOWMINNOACTIVE) ? SW_SHOWNORMAL : nCmdShow;

  MdiClient = new TCEdMDIClient(this);
  TDecoratedMDIFrame* frame = new TDecoratedMDIFrame(Name, IDM_MDI, *MdiClient, true, this);


  // Enable acceptance of dropped files
  //
  frame->ModifyExStyle(0,WS_EX_ACCEPTFILES);

  nCmdShow = (nCmdShow != SW_SHOWMINNOACTIVE) ? SW_SHOWNORMAL : nCmdShow;

  // Assign icons for this application.
  //
  frame->SetIcon(this, IDI_MDIAPPLICATION);
  frame->SetIconSm(this, IDI_MDIAPPLICATION);

  // Associate with the accelerator table.
  //
  frame->SetAcceleratorTable(IDM_MDI);

  TStatusBar* sb = new TStatusBar(frame,TGadget::Recessed,
                                  TStatusBar::CapsLock        |
                                  TStatusBar::NumLock         |
                                  TStatusBar::SizeGrip,
                                  new TDefaultGUIFont);
  sb->SetWideHints(false);

  //ID_LINEINDICATOR
  TGadget* textGadget =
    new TDynamicTextGadget(ID_LINEINDICATOR, TTextGadget::Recessed,
                           TTextGadget::Left, 4);
  sb->Insert(*textGadget);

  //ID_DIRTYINDICATOR
  TGadget* bmpGadget =
    new TDynamicBitmapGadget(ID_DIRTYINDICATOR, ID_DIRTYINDICATOR,
                             TTextGadget::Recessed, 3);
  sb->Insert(*bmpGadget, TStatusBar::Before);

  //ID_INSERTINDICATOR
  textGadget = new TDynamicTextGadget(ID_INSERTINDICATOR,
               TTextGadget::Recessed, TTextGadget::Center,
               3,_T("INS"));
  textGadget->SetShrinkWrap(true, true);

  TMargins margins = textGadget->GetMargins();

  // Use small left and right margins
  //
  margins.Left = margins.Right = 2;
  textGadget->SetMargins(margins);

  TGadget* gd = sb->GadgetWithId(IDG_STATUS_NUM);
  sb->Insert(*textGadget,TStatusBar::After, gd);

  frame->Insert(*sb, TDecoratedFrame::Bottom);

  SetupSpeedBar(frame);

  SetMainWindow(frame);

  frame->SetMenuDescr(TMenuDescr(IDM_MDI));

  TGadgetWindow::EnableFlatStyle();
}

//--------------------------------------------------------
// TCoolEditAppl
// ~~~~~
// Application instance initialization.
//
void TCoolEditAppl::InitInstance()
{
  TApplication::InitInstance();

  ProcessCmdLine(GetCmdLine().c_str());
}
//--------------------------------------------------------
// TCoolEditAppl
// ~~~~~
// Process command line parameters.
//
void TCoolEditAppl::ProcessCmdLine(LPCTSTR cmdLine)
{
  RegisterInfo();

  TCmdLine cmd(cmdLine);

  while (cmd.Kind != TCmdLine::Done) {
    if (cmd.Kind == TCmdLine::Option) {
      if (_tcsnicmp(cmd.Token, _T("unregister"), cmd.TokenLen) == 0){
        UnRegisterInfo();
      }
    }
    else if (cmd.Kind == TCmdLine::Name) {
      TDocTemplate* tpl = GetDocManager()->MatchTemplate(cmd.Token);
      if (tpl)
        GetDocManager()->CreateDoc(tpl, cmd.Token);
    }
    cmd.NextToken();
  }
}
//--------------------------------------------------------
TConfigFile* TCoolEditAppl::CreateConfigFile()
{
  return new TRegConfigFile(GetAppRegPath());
}

//--------------------------------------------------------
// TCoolEditAppl
// ~~~~~
// Register application info.
//
void TCoolEditAppl::RegisterInfo()
{
  TAPointer<_TCHAR> buffer = new _TCHAR[_MAX_PATH];
  GetModuleFileName(buffer, _MAX_PATH);
  TRegKey(TRegKey::GetClassesRoot(), _T("ced.Application\\DefaultIcon")).SetDefValue(0, REG_SZ, buffer, _tcslen(buffer));
  _tcscat(buffer, _T(",1"));

  TRegKey(TRegKey::GetClassesRoot(), _T("ced.Document.1\\DefaultIcon")).SetDefValue(0, REG_SZ, buffer, _tcslen(buffer));
  _tcscpy(buffer, "ced.Document.1");
  TRegKey(TRegKey::GetClassesRoot(), _T(".txt")).SetDefValue(0, REG_SZ, buffer, _tcslen(buffer));
}

//--------------------------------------------------------
// TCoolEditAppl
// ~~~~~
// Unregister application info.
//
void TCoolEditAppl::UnRegisterInfo()
{
  TAPointer<_TCHAR> buffer = new _TCHAR[_MAX_PATH];

  GetModuleFileName(buffer, _MAX_PATH);

  TRegKey(TRegKey::GetClassesRoot(), _T("ced.Application")).DeleteKey(_T("DefaultIcon"));
  TRegKey(TRegKey::GetClassesRoot(), _T("ced.Document.1")).DeleteKey(_T("DefaultIcon"));

  TRegKey::ClassesRoot.DeleteKey(_T("ced.Application"));
  TRegKey::ClassesRoot.DeleteKey(_T("ced.Document.1"));
  TRegKey::ClassesRoot.DeleteKey(_T(".txt"));
}

//-----------------------------------------------------------------------------
// TCoolEditAppl
// ~~~~~
// Response Table handlers:
//
void TCoolEditAppl::EvNewView(TView& view)
{
  TMDIClient* mdiClient = TYPESAFE_DOWNCAST(GetMainWindow()->GetClientWindow(), TMDIClient);
  if (mdiClient) {
    TCEdChild* child = new TCEdChild(*mdiClient, 0, view.GetWindow());

    // Set the menu descriptor for this view.
    //
    if (view.GetViewMenu())
       child->SetMenuDescr(*view.GetViewMenu());
    if (view.GetViewBar())
       child->SetBarDescr(view.GetViewBar(),NoAutoDelete);

    // Assign icons with this child window.??????
    LPCTSTR id_str = view.GetDocument().GetTemplate()->GetRegList()["iconindex"];
    int iconIdx = _ttol(id_str ? id_str : _T("0"));//set default ???
    if(iconIdx){
      child->SetIcon(this, iconIdx);
      child->SetIconSm(this, iconIdx);
    }
    child->Create();
  }
}
//-----------------------------------------------------------------------------
void TCoolEditAppl::EvCloseView(TView&)
{
}
//-----------------------------------------------------------------------------
void TCoolEditAppl::CeFileSend(TCommandEnabler& ce)
{
  ce.Enable((GetDocManager()->GetCurrentDoc() != 0)
            && ApxMail->IsMAPIAvailable());
}
//-----------------------------------------------------------------------------

void TCoolEditAppl::CmFileSend ()
{
  // Check to see if a document exists
  //
  TDocument* currentDoc = GetDocManager()->GetCurrentDoc();

  if (currentDoc) {
    TAPointer<_TCHAR> savedPath = new _TCHAR[_MAX_PATH];
    TAPointer<_TCHAR> docName = new _TCHAR[_MAX_PATH];

    bool dirtyState = currentDoc->IsDirty();

    if (currentDoc->GetDocPath())
      _tcscpy(savedPath, currentDoc->GetDocPath());
    else
      _tcscpy(savedPath, _T(""));

    if (currentDoc->GetTitle())
      _tcscpy(docName, currentDoc->GetTitle());
    else
      _tcscpy(docName, _T("Document"));

    TFileName tempFile(TFileName::TempFile);

    currentDoc->SetDocPath(tempFile.Canonical().c_str());
    currentDoc->Commit(true);

    currentDoc->SetDocPath(savedPath);
    currentDoc->SetDirty(dirtyState);

    ApxMail->SendDocuments(GetMainWindow(), tempFile.Canonical().c_str(), docName, false);

    tempFile.Remove();
  }
}
//-----------------------------------------------------------------------------

// TCoolEditAppl
// ~~~~~
// Menu Help Contents command
//
void TCoolEditAppl::CmHelpContents()
{
  // Show the help table of contents.
  //
  HelpState = GetMainWindow()->WinHelp(HelpFileName, HELP_CONTENTS, 0);
}
//-----------------------------------------------------------------------------

// Menu Help Using Help command
void TCoolEditAppl::CmHelpUsing()
{
  // Display the contents of the Windows help file.
  //
  HelpState = GetMainWindow()->WinHelp(HelpFileName, HELP_HELPONHELP, 0);
}
//-----------------------------------------------------------------------------
// Menu Help About ced command
void TCoolEditAppl::CmHelpAbout()
{
  // Show the modal dialog.
  //
  TCoolEditAboutDlg(GetMainWindow()).Execute();
}
//-----------------------------------------------------------------------------
// Shows how to work with Property Page
struct __TCoolApplStr{
  __TCoolApplStr():Appl(0),xFer(0){}
  TCoolEditAppl* Appl;
  TEditPropDlgXfer* xFer;
  int CallBack(TEditPropDlg*,bool);
};

//-----------------------------------------------------------------------------
int __TCoolApplStr::CallBack(TEditPropDlg* dlg, bool appl)
{
  PRECONDITION(Appl && xFer);

  //PSNRET_INVALID_NOCHANGEPAGE
  if(appl==TEditPropDlgXfer::ctApply){
    TPointer<TConfigFile> config = Appl->CreateConfigFile();
    xFer->SaveData(*(TConfigFile*)config);
    // reset
  }
  else if(appl==TEditPropDlgXfer::ctReset){
    TPointer<TConfigFile> config = Appl->CreateConfigFile();
    xFer->LoadData((TConfigFile*)config);
  }
  else
    return PSNRET_INVALID_NOCHANGEPAGE;
  return PSNRET_NOERROR;
}
//-----------------------------------------------------------------------------
void TCoolEditAppl::CmOptionsPref ()
{
  __TCoolApplStr applStr;
  TEditPropDlgXfer xFer(TPSheet_MFUNCTOR(applStr, __TCoolApplStr::CallBack));
  applStr.Appl = this;
  applStr.xFer = &xFer;

  {TPointer<TConfigFile> config = CreateConfigFile();
   xFer.LoadData((TConfigFile*)config);}

  TPropertySheet dlg(GetMainWindow(), "Preferences");

  dlg.EnableSubclass(true); // subclass sheet
  new TEditPropDlg(&dlg, xFer);
  new TGlyphButton(&dlg, IDOK,    TGlyphButton::btOk);
  new TGlyphButton(&dlg, IDCANCEL,TGlyphButton::btCancel);
  new TGlyphButton(&dlg, ID_APPLY,TGlyphButton::btApply);
  new TGlyphButton(&dlg, IDHELP,  TGlyphButton::btHelp);

  dlg.Execute();
}
//-----------------------------------------------------------------------------
void TCoolEditAppl::EvDropFiles(TDropInfo drop)
{
  TFileDropletList files;

  // Iterate thru the entries in drop and create FileDrops objects for each
  // one.
  int fileCount = drop.DragQueryFileCount();  // Number of files dropped.
  for (int i = 0; i < fileCount; i++)
    files.Add(new TFileDroplet(drop, i));

  // Open the files that were dropped.
  //
  AddFiles(files);

  // Release the memory allocated for this handle with DragFinish.
  //
  drop.DragFinish();
}
//-----------------------------------------------------------------------------

void TCoolEditAppl::AddFiles(TFileDropletList& files)
{
  // Open all files dragged in.
  //
  for (TFileDropletListIter fileIter(files); fileIter; fileIter++) {
    TDocTemplate* tpl = GetDocManager()->MatchTemplate((*fileIter)->GetName());
    if(tpl)
      GetDocManager()->CreateDoc(tpl, (*fileIter)->GetName());
  }
}
//-----------------------------------------------------------------------------
void TCoolEditAppl::EvOwlDocument(TDocument& doc)
{
  if(doc.GetDocPath())
    SaveMenuChoice(doc.GetDocPath());
}
//-----------------------------------------------------------------------------
int32 TCoolEditAppl::CmFileSelected(uint wp, int32)
{
  TAPointer<_TCHAR> text = new _TCHAR[_MAX_PATH];

  GetMenuText(wp, text, _MAX_PATH);
  TDocTemplate* tpl = GetDocManager()->MatchTemplate(text);
  if(tpl==0 || GetDocManager()->CreateDoc(tpl, text)==0)
    RemoveMenuChoice(text);
  return 0;
}
//-----------------------------------------------------------------------------
// Process application messages to provide context sensitive help
//
bool TCoolEditAppl::ProcessAppMsg(MSG& msg)
{
  if (msg.message == WM_COMMAND) {
    if (ContextHelp || ::GetKeyState(VK_F1) < 0) {
      ContextHelp = false;
      GetMainWindow()->WinHelp(HelpFileName, HELP_CONTEXT, msg.wParam);
      return true;
    }
  }
  else{
    switch(msg.message) {
    case WM_KEYDOWN:
      if (msg.wParam == VK_F1) {
        // If the Shift/F1 then set the help cursor and turn on the modal help state.
        //
        if (::GetKeyState(VK_SHIFT) < 0) {
          ContextHelp = true;
          HelpCursor = new TCursor(GetMainWindow()->GetModule()->GetInstance(), TResId(IDC_HELPCURSOR));
          ::SetCursor(*HelpCursor);
          return true;        // Gobble up the message.
        }
        else {
          // If F1 w/o the Shift key then bring up help's main index.
          //
          GetMainWindow()->WinHelp(HelpFileName, HELP_INDEX, 0);
          return true;        // Gobble up the message.
        }
      }
      else {
        if (ContextHelp && msg.wParam == VK_ESCAPE) {
          if (HelpCursor)
            delete HelpCursor;
          HelpCursor = 0;
          ContextHelp = false;
          GetMainWindow()->SetCursor(0, IDC_ARROW);
          return true;    // Gobble up the message.
        }
      }
      break;

    case WM_MOUSEMOVE:
    case WM_NCMOUSEMOVE:
      if (ContextHelp) {
        ::SetCursor(*HelpCursor);
        return true;        // Gobble up the message.
      }
      break;

    case WM_INITMENU:
      if (ContextHelp) {
        ::SetCursor(*HelpCursor);
        return true;    // Gobble up the message.
      }
      break;
    case WM_ENTERIDLE:
      if (msg.wParam == MSGF_MENU){
        if (GetKeyState(VK_F1) < 0) {
          ContextHelp = true;
          GetMainWindow()->PostMessage(WM_KEYDOWN, VK_RETURN, 0);
          return true;     // Gobble up the message.
        }

      }

      break;
    default:
      ;
    }  // End of message switch
  }
  // Continue normal processing.
  //
  return TApplication::ProcessAppMsg(msg);
}

void TCoolEditAppl::EvWinIniChange(LPTSTR section)
{
  if (_tcscmp(section, "windows") == 0) {
    // If the device changed in the WIN.INI file then the printer
    // might have changed.  If we have a TPrinter(Printer) then
    // check and make sure it's identical to the current device
    // entry in WIN.INI.
    //
    if (Printer) {
      const int bufferSize = 255;
      _TCHAR printDBuffer[bufferSize];
      LPSTR printDevice = printDBuffer;
      LPSTR devName;
      LPSTR driverName = 0;
      LPSTR outputName = 0;
      if (::GetProfileString("windows", "device", "", printDevice, bufferSize)) {
        // The string which should come back is something like:
        //
        //      HP LaserJet III,hppcl5a,LPT1:
        //
        // Where the format is:
        //
        //      devName,driverName,outputName
        //
        devName = printDevice;
        while (*printDevice) {
          if (*printDevice == ',') {
            *printDevice++ = 0;
            if (!driverName)
              driverName = printDevice;
            else
              outputName = printDevice;
          }
          else
            printDevice = ::AnsiNext(printDevice);
        }

        if (Printer->GetSetup().Error != 0                ||
            strcmp(devName, Printer->GetSetup().GetDeviceName()) != 0  ||
            strcmp(driverName, Printer->GetSetup().GetDriverName()) != 0 ||
            strcmp(outputName, Printer->GetSetup().GetOutputName()) != 0 ) {
          // New printer installed so get the new printer device now.
          //
          delete Printer;
          Printer = new TPrinter(this);
        }
      }
      else {
        // No printer installed(GetProfileString failed).
        //
        delete Printer;
        Printer = new TPrinter(this);
      }
    }
  }
}
//-----------------------------------------------------------------------------
// OwlMain
// ~~~~~~~
// Application Start here.
//
int OwlMain(int , LPTSTR [])
{
  return TCoolEditAppl().Run();
}
//-----------------------------------------------------------------------------
