//----------------------------------------------------------------------------
//  Project ced
//  OWL NExt
//  Copyright 2000. All Rights reserved.
//
//  SUBSYSTEM:    ced Application
//  FILE:         cedapp.h
//  AUTHOR:       Yura
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TCoolEditAppl (TApplication).
//  (Generated by OWL 6.0 Wizard for MS VC++. Version 1.5)
//----------------------------------------------------------------------------
#if !defined(cedapp_h) // Sentry, use file only if it's not already included.
#define cedapp_h

#include <owl/controlb.h>
#include <owl/docking.h>
#include <owl/mailer.h>
#include <owl/printer.h>
#include <owl/rcntfile.h>
#include <owl/docview.h>

#include "cedmdicl.h"        // Definition of MDI client class.
//#include "resource.h"           // Definition of all resources.

__OWL_DECLCLASS(TConfigFile);

const int vnCoolModify = vnCustomBase+1;
const int vnCoolReset  = vnCustomBase+2;
NOTIFY_SIG(vnCoolModify, const TRect*)
NOTIFY_SIG(vnCoolResetSetting, void)
#define EV_VN_COOLMODIFY	VN_DEFINE(vnCoolModify,	VnCoolModify, pointer)
#define EV_VN_COOLRESET		VN_DEFINE(vnCoolReset,  VnCoolReset,  void)



//{{TApplication = TCoolEditAppl}}
class TCoolEditAppl : public TApplication, public TRecentFiles {
  private:
    bool            HelpState;                          // Has the help engine been used.
    bool            ContextHelp;                        // SHIFT-F1 state(context sensitive HELP).
    TCursor*        HelpCursor;                         // Context sensitive help cursor.

    bool UserBarInserter(TDecoratedFrame& frame, TGadgetWindow& destWindow, TAbsLocation loc);
    void SetupSpeedBar(TDecoratedMDIFrame* frame);
    void AddFiles(TFileDropletList& files);
    void ProcessCmdLine(LPCTSTR CmdLine);
    void RegisterInfo();
    void UnRegisterInfo();

  public:
    TCoolEditAppl();
    virtual ~TCoolEditAppl();

    TConfigFile* CreateConfigFile();


    THarbor*        ApxHarbor;

    TCEdMDIClient*  MdiClient;

    // Public data members used by the print menu commands and Paint routine in MDIChild.
    //
    TPrinter*       Printer;                           // Printer support.
    int             Printing;                          // Printing in progress.

    TMailer*        ApxMail;

//{{TCoolEditApplVIRTUAL_BEGIN}}
  public:
    virtual void InitMainWindow();
    virtual void InitInstance();
    virtual bool CanClose();
    virtual bool ProcessAppMsg(MSG& msg);
//{{TCoolEditApplVIRTUAL_END}}

//{{TCoolEditApplRSP_TBL_BEGIN}}
  protected:
    void EvNewView(TView& view);
    void EvCloseView(TView& view);
    void CeFileSend(TCommandEnabler& ce);
    void CmFileSend();
    void CmHelpAbout();
    void CmHelpContents();
    void CmHelpUsing();
    void EvDropFiles(TDropInfo drop);
    void EvWinIniChange(LPTSTR section);
    void EvOwlDocument(TDocument& doc);
    int32 CmFileSelected(uint wp, int32 lp);
		void CmOptionsPref ();
//{{TCoolEditApplRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TCoolEditAppl);
};    //{{TCoolEditAppl}}


#endif  // cedapp_h sentry.
