//----------------------------------------------------------------------------
//  Project ced
//  OWL NExt
//  Copyright 2000. All Rights reserved.
//
//  SUBSYSTEM:    ced Application
//  FILE:         cedcl.cpp
//  AUTHOR:       Yura
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TCEdView (TPaneSplitterView).
//  (Generated by OWL 6.x Wizard for MS VC++. Version 1.5)
//----------------------------------------------------------------------------
#include "owlpch.h"
#include <owl/functor.h>

#include "cedapp.h"
#include "cedcl.h"
#include "coolprj/cooldoc.h"
#include "cededit.h"

//#include <stdio.h>

#include "resource.h"          // Definition of all resources.

TGadget* UserGadgetBuilder(int index, int cmdId, bool& usecell);

//{{TCEdView Implementation}}

//
// Build a response table for all messages/commands handled
// by TCEdView derived from TEditView.
//
DEFINE_RESPONSE_TABLE1(TCEdView, TPaneSplitterView)
//{{TCEdViewRSP_TBL_BEGIN}}
	EV_COMMAND(CM_EDITCLEAR_BOOKMARKS,			CmEditClearBookmarks),
	EV_COMMAND(CM_EDITTOGGLE_BOOKMARK,			CmEditToggleBookmark),
	EV_COMMAND(CM_EDITGOTO_NEXT_BOOKMARK,		CmEditGotoNextBookmark),
	EV_COMMAND(CM_EDITGOTO_PREV_BOOKMARK,		CmEditGotoPrevBookmark),
	EV_COMMAND(CM_EDITCLEAR_ALL_BOOKMARKS,	CmEditClearAllBookmarks),

	EV_COMMAND_AND_ID(CM_EDITGO_BOOKMARK0, 	CmEditGotoRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITGO_BOOKMARK1, 	CmEditGotoRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITGO_BOOKMARK2, 	CmEditGotoRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITGO_BOOKMARK3, 	CmEditGotoRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITGO_BOOKMARK4, 	CmEditGotoRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITGO_BOOKMARK5, 	CmEditGotoRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITGO_BOOKMARK6, 	CmEditGotoRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITGO_BOOKMARK7, 	CmEditGotoRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITGO_BOOKMARK8, 	CmEditGotoRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITGO_BOOKMARK9, 	CmEditGotoRandBookmark),

	EV_COMMAND_AND_ID(CM_EDITTOGGLE_BOOKMARK0, CmEditToggleRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITTOGGLE_BOOKMARK1, CmEditToggleRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITTOGGLE_BOOKMARK2, CmEditToggleRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITTOGGLE_BOOKMARK3, CmEditToggleRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITTOGGLE_BOOKMARK4, CmEditToggleRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITTOGGLE_BOOKMARK5, CmEditToggleRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITTOGGLE_BOOKMARK6, CmEditToggleRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITTOGGLE_BOOKMARK7, CmEditToggleRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITTOGGLE_BOOKMARK8, CmEditToggleRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITTOGGLE_BOOKMARK9, CmEditToggleRandBookmark),

	EV_COMMAND(CM_EDITREADONLY,			CmEditReadonly),
	EV_COMMAND(CM_EDITVIEWSELECTION,CmEditViewselection),
	EV_COMMAND(CM_EDITSMARTCURSOR,	CmEditSmartcursor),
	EV_COMMAND(CM_EDITWHITESPACE,		CmEditWhitespace),
	EV_COMMAND(CM_EDITVIEWCARET,		CmEditViewcaret),
	EV_COMMAND(CM_EDITSELLINE,			CmEditSelline),
	EV_COMMAND(CM_EDITSELCOLUMN,		CmEditSelcolumn),
	EV_COMMAND(CM_EDIT_VIEWLINENUM, CmEditViewlinenum),

  EV_WM_GETMINMAXINFO,
	EV_VN_COOLMODIFY,
	EV_COMMAND(CM_WINDOW_HSPLIT, CmWindowHSplit),
	EV_COMMAND(CM_WINDOW_VSPLIT, CmWindowVSplit),
//{{TCEdViewRSP_TBL_END}}
END_RESPONSE_TABLE;


//--------------------------------------------------------
// TCEdView
// ~~~~~~~~~~
// Construction/Destruction handling.
//
TCEdView::TCEdView(TDocument& doc, TWindow* parent)
:
  TPaneSplitterView(doc, parent)
{
	DeleteOnClose(TShouldDelete::Delete);
  ModifyStyle(0,WS_CLIPSIBLINGS|WS_CLIPCHILDREN);

	SetAcceleratorTable(IDA_EDITVIEW);
	SetViewMenu(new TMenuDescr(IDM_EDITVIEW));

  TBarDescr* barDescr = new TBarDescr(IDB_EDITVIEW, GetModule());
  barDescr->SetBuilder(TGadget_FUNCTOR(UserGadgetBuilder));
	SetViewBar(barDescr);
}
//
TCEdView::~TCEdView()
{
  // INSERT>> Your destructor code here.
}
//
TCoolTextBuffer* 
TCEdView::GetBuffer()
{
	return &((TCoolDocument&)GetDocument()).GetTextBuffer();
}
//
void TCEdView::EvGetMinMaxInfo(MINMAXINFO far& minmaxinfo)
{
  TCoolEditAppl* theApp = TYPESAFE_DOWNCAST(GetApplication(), TCoolEditAppl);
  if (theApp) {
    if (theApp->Printing) {
      minmaxinfo.ptMaxSize = TPoint(32000, 32000);
      minmaxinfo.ptMaxTrackSize = TPoint(32000, 32000);
      return;
    }
  }
  Inherited::EvGetMinMaxInfo(minmaxinfo);
}
//
void TCEdView::SetupWindow()
{	
	// Call base class function.
	Inherited::SetupWindow();
  
	TCEditPane* pane = new TCEditPane(this, 0);
  SplitPane(pane, 0, psNone);
	pane->SetFocus();
}
//
void TCEdView::CmWindowHSplit ()
{	
  TWindow* curChild = GetWindowPtr(GetApplication()->GetMainWindow()->GetCommandTarget());
	TCEditPane* pane = new TCEditPane(this, 0);
  SplitPane(curChild, pane, psHorizontal);
  pane->SetFocus();
}
//
void TCEdView::CmWindowVSplit ()
{	
  TWindow* curChild = GetWindowPtr(GetApplication()->GetMainWindow()->GetCommandTarget());
	TCEditPane* pane = new TCEditPane(this, 0);
  SplitPane(curChild, pane, psVertical);
  pane->SetFocus();
}
//
TCEditPane* TCEdView::GetCurrentPane()
{
  TWindow* curChild = GetWindowPtr(GetApplication()->GetMainWindow()->GetCommandTarget());
	TCEditPane* editPane = 0;
	if(curChild)
		editPane = TYPESAFE_DOWNCAST(curChild, TCEditPane);
	return editPane;
}
//
static int invalidatePaneRect(TWindow& wnd, void* param)
{
	TRect* rect = (TRect*)param;
	TCEditPane* pane = TYPESAFE_DOWNCAST(&wnd, TCEditPane);
	CHECK(pane);
	if(rect)
		pane->InvalidatePane(rect->left, rect->right, rect->top != 0 ? true : false);
	else
		pane->Invalidate();
  return 1;
}
//
void TCEdView::InvalidateLines(int startLine, int endLine2, 
															 bool invalidateMargin)
{
	TRect rect(startLine, invalidateMargin ? 1 : 0, endLine2, 0);
  ForEachPane(invalidatePaneRect, (void*)&rect);
	GetDocument().NotifyViews(vnCoolModify, (long)&rect, this);
}
//
static int adjustScroller(TWindow& wnd, void*)
{
	TCEditPane* pane = TYPESAFE_DOWNCAST(&wnd, TCEditPane);
	CHECK(pane);
	pane->AdjustPaneScroller();
  return 1;
}
//
void TCEdView::AdjustScroller()
{
	static bool inwork = false;
	if(!inwork){
		inwork = true;
	  ForEachPane(adjustScroller,0);
		inwork = false;
	}
}
//
bool TCEdView::VnCoolModify(const TRect* rect)
{
  ForEachPane(invalidatePaneRect, (void*)rect);
	return true;
}
//-----------------------------------------------------------------------------
bool TCEdView::VnCoolReset()
{
	return true;
}
//-----------------------------------------------------------------------------
void TCEdView::CmEditClearBookmarks ()
{	
	GetCurrentPane()->ClearBookmarks();
	VnCoolModify(0);
}
//
void TCEdView::CmEditToggleBookmark ()
{	
	GetCurrentPane()->ToggleRandBookmark();
	VnCoolModify(0);
}
//-----------------------------------------------------------------------------
void TCEdView::CmEditGotoNextBookmark ()
{	
	GetCurrentPane()->NextRandBookmark();
	VnCoolModify(0);
}
//-----------------------------------------------------------------------------
void TCEdView::CmEditGotoPrevBookmark ()
{	
	GetCurrentPane()->PrevRandBookmark();
	VnCoolModify(0);
}
//-----------------------------------------------------------------------------
void TCEdView::CmEditClearAllBookmarks ()
{	
	GetCurrentPane()->ClearRandBookmarks();
	VnCoolModify(0);
}
//-----------------------------------------------------------------------------
void TCEdView::CmEditGotoRandBookmark (uint id)
{
	int bookmarkId = id - CM_EDITGO_BOOKMARK0;
	GetCurrentPane()->GoBookmark(bookmarkId);
}
//-----------------------------------------------------------------------------
void TCEdView::CmEditToggleRandBookmark(uint id)
{
	int bookmarkId = id - CM_EDITTOGGLE_BOOKMARK0;
	GetCurrentPane()->ToggleBookmark(bookmarkId);
	VnCoolModify(0);
}
//-----------------------------------------------------------------------------
static int enableReadOnly(TWindow& wnd, void* param)
{
	bool enable = (bool)param;
	TCEditPane* pane = TYPESAFE_DOWNCAST(&wnd, TCEditPane);
	CHECK(pane);
	pane->EnableReadOnly(!enable);
  return 1;
}
//-----------------------------------------------------------------------------
void TCEdView::CmEditReadonly ()
{	
  ForEachPane(enableReadOnly, (void*)(bool)GetCurrentPane()->IsReadOnly());
}
//-----------------------------------------------------------------------------
static int enableShowInactiveSel(TWindow& wnd, void* param)
{
	bool enable = (bool)param;
	TCEditPane* pane = TYPESAFE_DOWNCAST(&wnd, TCEditPane);
	CHECK(pane);
	pane->EnableShowInactiveSel(!enable);
  return 1;
}
//-----------------------------------------------------------------------------
void TCEdView::CmEditViewselection ()
{	
  ForEachPane(enableShowInactiveSel, (void*)(bool)GetCurrentPane()->IsShowInactiveSel());
}
//-----------------------------------------------------------------------------
static int enableSmartCursor(TWindow& wnd, void* param)
{
	bool enable = (bool)param;
	TCEditPane* pane = TYPESAFE_DOWNCAST(&wnd, TCEditPane);
	CHECK(pane);
	pane->EnableSmartCursor(!enable);
  return 1;
}
//-----------------------------------------------------------------------------
void TCEdView::CmEditSmartcursor ()
{	
  ForEachPane(enableSmartCursor, (void*)(bool)GetCurrentPane()->IsSmartCursor());
}
//-----------------------------------------------------------------------------
static int enableTabs(TWindow& wnd, void* param)
{
	bool enable = (bool)param;
	TCEditPane* pane = TYPESAFE_DOWNCAST(&wnd, TCEditPane);
	CHECK(pane);
	pane->EnableTabs(!enable);
  return 1;
}
//-----------------------------------------------------------------------------
void TCEdView::CmEditWhitespace ()
{	
  ForEachPane(enableTabs, (void*)(bool)GetCurrentPane()->IsTabsVisible());
}
//-----------------------------------------------------------------------------
static int enableCaret(TWindow& wnd, void* param)
{
	bool enable = (bool)param;
	TCEditPane* pane = TYPESAFE_DOWNCAST(&wnd, TCEditPane);
	CHECK(pane);
	pane->EnableCaret(!enable);
  return 1;
}
//-----------------------------------------------------------------------------
void TCEdView::CmEditViewcaret ()
{	
  ForEachPane(enableCaret, (void*)(bool)GetCurrentPane()->IsCaretEnable());
}
//-----------------------------------------------------------------------------
static int showLineNumbers(TWindow& wnd, void* param)
{
	bool enable = (bool)param;
	TCEditPane* pane = TYPESAFE_DOWNCAST(&wnd, TCEditPane);
	CHECK(pane);
	pane->ShowLineNumbers(!enable);
  return 1;
}
//-----------------------------------------------------------------------------
void TCEdView::CmEditViewlinenum ()
{	
  ForEachPane(showLineNumbers, (void*)(bool)GetCurrentPane()->IsLineNumbers());
}
//-----------------------------------------------------------------------------
static int setSelMode(TWindow& wnd, void* param)
{
	TCoolTextWnd::TSelType type = (TCoolTextWnd::TSelType)(int)param;
	TCEditPane* pane = TYPESAFE_DOWNCAST(&wnd, TCEditPane);
	CHECK(pane);
	pane->SetSelMode(type);
  return 1;
}
//-----------------------------------------------------------------------------
void TCEdView::CmEditSelline ()
{	
  ForEachPane(setSelMode, (void*)TCoolTextWnd::stLineSelection);
}
//-----------------------------------------------------------------------------
void TCEdView::CmEditSelcolumn ()
{	
  ForEachPane(setSelMode, (void*)TCoolTextWnd::stColumnSelection);
}
//-----------------------------------------------------------------------------
