//----------------------------------------------------------------------------
//  Project ced
//  OWL NExt
//  Copyright 2000. All Rights reserved.
//
//  SUBSYSTEM:    ced Application
//  FILE:         cededit.cpp
//  AUTHOR:       Yura
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TCEditPane (TCoolEdit).
//  (Generated by OWL 6.x Class Expert for MS VC++, Version 1.5)
//----------------------------------------------------------------------------
#include "owlpch.h"

#include "cedapp.h"
#include "cededit.h"
#include "cedcl.h"
#include "coolprj/cooledit.rh"  // Definition of cooledit
#include "resource.h"    // Definition of all resources.


//-----------------------------------------------------------------------------
TRegularExExEngine::TRegularExExEngine(const owl_string& pattern,
																			 bool caseSens,bool up)
:
	CaseSens(caseSens),DirectUp(up),Rxnode(0)
{
	Rxnode = ::RxCompile (pattern.c_str());
}
//-----------------------------------------------------------------------------
TRegularExExEngine::~TRegularExExEngine()
{
	if (Rxnode)
		::RxFree (Rxnode);
}
//-----------------------------------------------------------------------------
/*
static int HowManyStr (LPCTSTR s, LPCTSTR m)
{
  LPCTSTR p = s;
  int n = 0, l = _tcslen (m);
  while ((p = _tcsstr (p, m)) != 0){
		n++;
    p += l;
  }
  return n;
}
*/
//-----------------------------------------------------------------------------
TEditRange 
TRegularExExEngine::Search(TCoolTextBuffer& buffer, const TEditRange& _range)
{
	//int nEolns = HowManyStr (what, _T("\\n"));
  if(!Rxnode)
		return TEditRange(); 

	// store pattern length locally (it gets used a lot)
  TEditRange searchRange(_range);
  if(!searchRange.Valid()){
    // if not valid -> all file
    searchRange.scol = 0;
    searchRange.srow = 0;
    searchRange.erow = buffer.GetLineCount()-1;
    searchRange.ecol = buffer.GetLineLength(searchRange.srow);
  }
  searchRange.Normalize();

  LPCTSTR pos = 0;
  int lineIndex = DirectUp ? searchRange.erow : searchRange.srow;
  int posIndex  = searchRange.scol;
  LPTSTR text   = buffer.GetLineText(lineIndex);

	int foundLen = 0;
  while(true){
    if(DirectUp){
      if(posIndex < searchRange.srow){
        lineIndex--;
        if(lineIndex < searchRange.srow)
          break;
        text      = buffer.GetLineText(lineIndex);
        posIndex  = buffer.GetLineLength(lineIndex);
      }
			if(::RxExec(Rxnode, text, posIndex,
					          text, &Rxmatch, CaseSens ? RX_CASE : 0)){
				pos			 = text + Rxmatch.Open[0];
				foundLen = Rxmatch.Close[0] - Rxmatch.Open[0];
			}
    }
    else {
      if(posIndex > buffer.GetLineLength(lineIndex)){
        lineIndex++;
        if(lineIndex>=buffer.GetLineCount() || lineIndex>=searchRange.erow)
          break;
        text    = buffer.GetLineText(lineIndex);
        posIndex  = 0;
      }
			if(::RxExec(Rxnode, text+posIndex, 
				          buffer.GetLineLength(lineIndex)-posIndex,
					        text+posIndex, &Rxmatch, CaseSens ? RX_CASE : 0)){
				pos			 = text + Rxmatch.Open[0];
				foundLen = Rxmatch.Close[0] - Rxmatch.Open[0];
			}
    }
    if(pos)
      break;
    else
      posIndex = DirectUp ? -1 : buffer.GetLineLength(lineIndex)+1;
  }

  // If we've got a match, select that text, cleanup & return.
  //
  if(pos)
    return TEditRange(pos-text, lineIndex, pos-text+foundLen, lineIndex);
  return TEditRange();
}
//-----------------------------------------------------------------------------


//{{TCEditPane Implementation}}

//
// Build a response table for all messages/commands handled
// by TCEdView derived from TCoolEdit.
//
DEFINE_RESPONSE_TABLE1(TCEditPane, TCoolEdit)
//{{TCEditPaneRSP_TBL_BEGIN}}
	EV_COMMAND_ENABLE(ID_LINEINDICATOR,		CeLineindicator),
	EV_COMMAND_ENABLE(ID_DIRTYINDICATOR,	CeDirtyIndicator),
	EV_COMMAND_ENABLE(ID_INSERTINDICATOR, CeInsertIndicator),
	EV_COMMAND_ENABLE(CM_EDITREADONLY,			CeEditReadonly),
	EV_COMMAND_ENABLE(CM_EDITVIEWSELECTION, CeEditViewselection),
	EV_COMMAND_ENABLE(CM_EDITSMARTCURSOR, CeEditSmartcursor),
	EV_COMMAND_ENABLE(CM_EDITWHITESPACE, CeEditWhitespace),
	EV_COMMAND_ENABLE(CM_EDITVIEWCARET, CeEditViewcaret),
	EV_COMMAND_ENABLE(CM_EDIT_SELSTREAM, CeEditSelstream),
	EV_COMMAND_ENABLE(CM_EDITSELLINE, CeEditSelline),

	EV_COMMAND_ENABLE(CM_EDITSELCOLUMN,		CeEditSelcolumn),
	EV_COMMAND_ENABLE(CM_EDIT_VIEWLINENUM,CeEditViewlinenum),
	EV_WM_LBUTTONDOWN,
	EV_WM_LBUTTONDBLCLK,
	EV_WM_RBUTTONDOWN,
	EV_WM_SETFOCUS,
	EV_WM_KILLFOCUS,
//{{TCEditPaneRSP_TBL_END}}
END_RESPONSE_TABLE;

//--------------------------------------------------------
// TCEditPane Constructor
//
TCEditPane::TCEditPane(TCEdView* parent,int id) 
: 
  TCoolEdit(0, id, _T(""),0,0,0,0,0),
	EditView(parent)
{
	ModifyStyle(0,WS_CLIPSIBLINGS);
  ModifyExStyle(0,WS_EX_CLIENTEDGE);
	SetAcceleratorTable(IDA_EDITVIEW);
  
	SearchData.EngineDescr.Flush(true);
  SearchData.EngineDescr.Add(new TBruteForceDescr);
  SearchData.EngineDescr.Add(new TBoyerMooreDescr);
  SearchData.EngineDescr.Add(new TRegularExDescr);
	SearchData.EngineDescr.Add(new TRegularExExDescr);
	SearchData.EngineDescr.Add(new TPhoneticDescr);
}
//--------------------------------------------------------
// TCEditPane Destructor
//
TCEditPane::~TCEditPane()
{
  Destroy(IDCANCEL);
}
//
void TCEditPane::SetupWindow()
{	
	// Call base class function.
	TCoolEdit::SetupWindow();

	TDocTemplate* tpl = EditView->GetDocument().GetTemplate();
	TParserCreator creator = GetCoolParserCreator(tpl);
	SetSyntaxParser(creator(this));
}
//
TCoolTextBuffer* 
TCEditPane::GetBuffer()
{
	return EditView->GetBuffer();
}
//
void TCEditPane::Paint(TDC& dc, bool erase, TRect& rect)
{	
	// Call base class function.
  TCoolEditAppl* theApp = TYPESAFE_DOWNCAST(GetApplication(), TCoolEditAppl);
  if (theApp) {
    // Only paint if we're printing and we have something to paint, otherwise do nothing.
    //
    if (theApp->Printing && theApp->Printer && !rect.IsEmpty()) {
      // Use pageSize to get the size of the window to render into.  For a Window it's the client area,
      // for a printer it's the printer DC dimensions and for print preview it's the layout window.
      TSize   pageSize(rect.right - rect.left, rect.bottom - rect.top);

      HFONT   hFont = (HFONT)GetWindowFont();
      TFont   font(_T("Arial"), -12);
      if (!hFont)
        dc.SelectObject(font);
      else
        dc.SelectObject(TFont(hFont));

      TEXTMETRIC  tm;
      int fHeight = dc.GetTextMetrics(tm) ? tm.tmHeight + tm.tmExternalLeading : 10;

      // How many lines of this font can we fit on a page.
      //
      int linesPerPage = MulDiv(pageSize.cy, 1, fHeight);
      if (linesPerPage) {
        TPrintDialog::TData& printerData = theApp->Printer->GetSetup();

        int maxPg = ((GetNumLines() / linesPerPage) + 1.0);

        // Compute the number of pages to print.
        //
        printerData.MinPage = 1;
        printerData.MaxPage = maxPg;

        // Do the text stuff:
        //
        int   fromPage = printerData.FromPage == -1 ? 1 : printerData.FromPage;
        int   toPage = printerData.ToPage == -1 ? 1 : printerData.ToPage;
        int   currentPage = fromPage;
        TAPointer<_TCHAR> buffer = new _TCHAR[255];

        while (currentPage <= toPage) {
          int startLine = (currentPage - 1) * linesPerPage;
          int lineIdx = 0;
          while (lineIdx < linesPerPage) {
            // If the string is no longer valid then there's nothing more to display.
            //
            if (!GetLine(buffer, 255, startLine + lineIdx))
              break;
            dc.TabbedTextOut(TPoint(0, lineIdx * fHeight), buffer, strlen(buffer), 0, 0, 0);
            lineIdx++;
          }
          currentPage++;
        }
      }
			return;
    }
  }
	Inherited::Paint(dc, erase, rect);
}
//
void 
TCEditPane::InvalidatePane(int startLine, int endLine2, bool invalidateMargin)
{
	Inherited::InvalidateLines(startLine, endLine2, invalidateMargin);
}
//
void TCEditPane::CeEditWhitespace (TCommandEnabler& tce)
{	
	tce.SetCheck(IsTabsVisible());
}
//
void TCEditPane::CeEditViewcaret (TCommandEnabler& tce)
{	
	tce.SetCheck(IsCaretEnable());
}
//
void TCEditPane::CeEditSelstream (TCommandEnabler& tce)
{	
	tce.SetCheck(IsStreamSelMode());
}
//
void TCEditPane::CeEditSelline (TCommandEnabler& tce)
{	
	tce.SetCheck(IsLineSelMode());
}
//
void TCEditPane::CeEditViewlinenum (TCommandEnabler& tce)
{	
	tce.SetCheck(IsLineNumbers());
}
//
void TCEditPane::CeEditSelcolumn (TCommandEnabler& tce)
{	
	tce.SetCheck(IsColumnSelMode());
}
//
void TCEditPane::CeLineindicator (TCommandEnabler& tce)
{	
	VERIFY_TEXTPOS(CursorPos);
  _TCHAR buffer[40];
  // VVV m_ptCursorPos.x + 1 ???
  wsprintf(buffer,_T ("Ln %d, Col %d"), CursorPos.row + 1, CursorPos.col + 1);
	tce.Enable(true);
	tce.SetText(buffer);
}
//
void TCEditPane::CeDirtyIndicator (TCommandEnabler& tce)
{
	VERIFY_TEXTPOS(CursorPos);
	//tce.Enable(true);
	tce.SetCheck(GetBuffer()->IsDirty() ? 1 : 0);
}
//-----------------------------------------------------------------------------
void TCEditPane::CeInsertIndicator (TCommandEnabler& tce)
{
	VERIFY_TEXTPOS(CursorPos);
	tce.Enable(IsOverType());
	tce.SetText(IsOverType() ? _T("OVR") : _T("INS"));
}
//-----------------------------------------------------------------------------
void TCEditPane::CeEditReadonly (TCommandEnabler& tce)
{	
	tce.SetCheck(IsReadOnly());
}
//-----------------------------------------------------------------------------
void TCEditPane::CeEditViewselection(TCommandEnabler& tce)
{	
	tce.SetCheck(IsShowInactiveSel());
}
//-----------------------------------------------------------------------------
void TCEditPane::CeEditSmartcursor (TCommandEnabler& tce)
{	
	tce.SetCheck(IsSmartCursor());
}
//-----------------------------------------------------------------------------
void TCEditPane::EvLButtonDown(uint modKeys, TPoint& point)
{	
	SetFocus();
	Inherited::EvLButtonDown(modKeys, point);
}
//-----------------------------------------------------------------------------
void TCEditPane::EvLButtonDblClk(uint modKeys, TPoint& point)
{	
	SetFocus();
	Inherited::EvLButtonDblClk(modKeys, point);
}
//-----------------------------------------------------------------------------
void TCEditPane::EvRButtonDown(uint modKeys, TPoint& point)
{	
	SetFocus();
	Inherited::EvRButtonDown(modKeys, point);
}
//-----------------------------------------------------------------------------
void TCEditPane::InvalidateLines(int startLine, int endLine2,
		      											bool invalidateMargin)
{
//	Inherited::InvalidateLines(startLine, endLine2, invalidateMargin);
	EditView->InvalidateLines(startLine, endLine2, invalidateMargin);
}
//-----------------------------------------------------------------------------
void TCEditPane::AdjustPaneScroller()
{
	Inherited::AdjustScroller();
}
//-----------------------------------------------------------------------------
void TCEditPane::AdjustScroller()
{
//	Inherited::AdjustScroller();
//	static bool inwork = false;
//	if(!inwork){
//		inwork == true;
		EditView->AdjustScroller();
//		inwork == false;
//	}
}
//-----------------------------------------------------------------------------
void TCEditPane::EvSetFocus(HWND hWndLostFocus)
{	
	Invalidate();
	Inherited::EvSetFocus(hWndLostFocus);
}
//-----------------------------------------------------------------------------
void TCEditPane::EvKillFocus(HWND hWndGetFocus)
{	
	Invalidate();
	Inherited::EvKillFocus(hWndGetFocus);
}
//-----------------------------------------------------------------------------
