//----------------------------------------------------------------------------
//  Project ced
//  OWL NExt
//  Copyright 2000. All Rights reserved.
//
//  SUBSYSTEM:    ced Application
//  FILE:         cededit.h
//  AUTHOR:       Yura
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TCEditPane (TCoolEdit).
//  (Generated by OWL 6.x Class Expert for MS VC++, Version 1.5)
//----------------------------------------------------------------------------
#if !defined(CEDEDIT_H) // Sentry, use file only if it's not already included.
#define CEDEDIT_H

#include <coolprj/cooledit.h>
//#include "..\core\cooledit.h"
#include <coolprj/regexp.h>

//-----------------------------------------------------------------------------
// class TRegularExExEngine
// ~~~~~ ~~~~~~~~~~~~~~~~~~
//
class TRegularExExEngine: public TCoolSearchEngine {
  public:
    TRegularExExEngine(const owl_string& pattern,
			                 bool caseSens=false,
                       bool up = false);
    ~TRegularExExEngine();
    virtual TEditRange Search(TCoolTextBuffer& buffer,
                              const TEditRange& searchRange=TEditRange());
  protected:
    bool        CaseSens;
    bool        DirectUp;
    RxNode*			Rxnode;
    RxMatchRes	Rxmatch;
};

//-----------------------------------------------------------------------------
// class TRegularExExDescr
// ~~~~~ ~~~~~~~~~~~~~~~~~
class TRegularExExDescr: public TCoolEngineDescr {
  public:
    TRegularExExDescr(){}
    owl_string GetName(){ return _T("Extended Regular expression"); }
		virtual uint GetCapability() { return ecNoWholeWord;}
    TCoolSearchEngine* Create(const owl_string& pattern,
                              bool caseSens=false,
                              bool wholeWord=false,
                              bool up = false)
      { return new TRegularExExEngine(pattern,caseSens,up);}
};
//
//
//

class TCEdView;

//{{TCoolEdit = TCEditPane}}
class TCEditPane: public TCoolEdit {
	typedef TCoolEdit Inherited;
  public:
    TCEditPane(TCEdView* parent,int id);
    virtual ~TCEditPane();
		void InvalidatePane(int startLine, int endLine2, bool invalidateMargin);
		void AdjustPaneScroller();

	private:
		TCEdView* EditView;

//{{TCEditPaneVIRTUAL_BEGIN}}
  public:
		virtual TCoolTextBuffer* GetBuffer();
		virtual void Paint(TDC& dc, bool erase, TRect& rect);
		virtual void SetupWindow();
		virtual void InvalidateLines(int startLine, int endLine2,
		      											 bool invalidateMargin);
    virtual void AdjustScroller();
//{{TCEditPaneVIRTUAL_END}}

//{{TCEditPaneRSP_TBL_BEGIN}}
  protected:
		void CeEditReadonly (TCommandEnabler& tce);
		void CeEditViewselection (TCommandEnabler& tce);
		void CeEditSmartcursor (TCommandEnabler& tce);
		void CeEditWhitespace (TCommandEnabler& tce);
		void CeEditViewcaret (TCommandEnabler& tce);
		void CeEditSelstream (TCommandEnabler& tce);
		void CeEditSelline (TCommandEnabler& tce);
		void CeEditSelcolumn (TCommandEnabler& tce);
		void CeLineindicator (TCommandEnabler& tce);
		void CeDirtyIndicator (TCommandEnabler& tce);
		void CeInsertIndicator (TCommandEnabler& tce);
		void EvLButtonDown(uint modKeys, TPoint& point);
		void EvLButtonDblClk(uint modKeys, TPoint& point);
		void EvRButtonDown(uint modKeys, TPoint& point);
		void EvSetFocus(HWND hWndLostFocus);
		void EvKillFocus(HWND hWndGetFocus);
		void CeEditViewlinenum (TCommandEnabler& tce);
//{{TCEditPaneRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TCEditPane);

}; //{{TCEditPane}}


#endif  // CEDEDIT_H sentry.

