//----------------------------------------------------------------------------
//  Project ced
//  OWL NExt
//  Copyright 2000. All Rights reserved.
//
//  SUBSYSTEM:    ced Application
//  FILE:         cedmdicl.cpp
//  AUTHOR:       Yura
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TCEdMDIClient (TMDIClient).
//  (Generated by OWL 6.x Wizard for MS VC++. Version 1.5)
//----------------------------------------------------------------------------
#include "owlpch.h"

#include <owl/docmanag.h>
#include <owl/listbox.h>
#include <stdio.h>

#include "cedapp.h"
#include "cedcl.h"
#include "cedmdich.h"
#include "apxprint.h"
#include "apxprev.h"


//{{TCEdMDIClient Implementation}}


//
// Build a response table for all messages/commands handled
// by TCEdMDIClient derived from TMDIClient.
//
DEFINE_RESPONSE_TABLE1(TCEdMDIClient, TMDIClient)
//{{TCEdMDIClientRSP_TBL_BEGIN}}
  EV_COMMAND(CM_FILEPRINT, CmFilePrint),
  EV_COMMAND(CM_FILEPRINTERSETUP, CmFilePrintSetup),
  EV_COMMAND(CM_FILEPRINTPREVIEW, CmFilePrintPreview),
  EV_COMMAND_ENABLE(CM_FILEPRINT, CmPrintEnable),
  EV_COMMAND_ENABLE(CM_FILEPRINTERSETUP, CmPrintEnable),
  EV_COMMAND_ENABLE(CM_FILEPRINTPREVIEW, CmPrintEnable),
  EV_WM_DROPFILES,
//{{TCEdMDIClientRSP_TBL_END}}
END_RESPONSE_TABLE;


//--------------------------------------------------------
// TCEdMDIClient
// ~~~~~~~~~~~
// Construction/Destruction handling.
//
TCEdMDIClient::TCEdMDIClient(TModule* module)
:
  TMDIClient(module),
  ChildCount(0)
{

  // INSERT>> Your constructor code here.

}


TCEdMDIClient::~TCEdMDIClient()
{
  Destroy();

  // INSERT>> Your destructor code here.

}


//--------------------------------------------------------
// TCEdMDIClient
// ~~~~~~~~~~~
// MDIClient site initialization.
//
void TCEdMDIClient::SetupWindow()
{
  // Default SetUpWindow processing.
  //
  TMDIClient::SetupWindow();

  // Accept files via drag/drop in the client window.
  //
  DragAcceptFiles(true);
}


//--------------------------------------------------------
// TCEdMDIClient
// ~~~~~~~~~~
// Menu File Print command
//
void TCEdMDIClient::CmFilePrint()
{
  // Create Printer object if not already created.
  //
  TCoolEditAppl* theApp = TYPESAFE_DOWNCAST(GetApplication(), TCoolEditAppl);
  if(theApp){
    if(!theApp->Printer)
      theApp->Printer = new TPrinter(theApp);

    TAPointer<_TCHAR> docName = new _TCHAR[_MAX_PATH];

    TDocument* currentDoc = theApp->GetDocManager()->GetCurrentDoc();
    if (currentDoc->GetTitle())
      _tcscpy(docName, currentDoc->GetTitle());
    else
      _tcscpy(docName, _T("Document"));

    // Create Printout window and set characteristics.
    //
    TApxPrintout printout(theApp->Printer, docName, GetActiveMDIChild()->GetClientWindow(), true);

    theApp->Printing++;

    // Bring up the Print dialog and print the document.
    //
    theApp->Printer->Print(GetWindowPtr(GetActiveWindow()), printout, true);

    theApp->Printing--;
  }
}


//--------------------------------------------------------
// TCEdMDIClient
// ~~~~~~~~~~
// Menu File Print Setup command
//
void TCEdMDIClient::CmFilePrintSetup()
{
  TCoolEditAppl* theApp = TYPESAFE_DOWNCAST(GetApplication(), TCoolEditAppl);
  if (theApp) {
    if (!theApp->Printer)
      theApp->Printer = new TPrinter(theApp);

    // Bring up the Print Setup dialog.
    //
    theApp->Printer->Setup(this);
  }
}


//--------------------------------------------------------
// TCEdMDIClient
// ~~~~~~~~~~
// Menu File Print Preview command
//
void TCEdMDIClient::CmFilePrintPreview()
{
  TCoolEditAppl* theApp = TYPESAFE_DOWNCAST(GetApplication(), TCoolEditAppl);
  if (theApp) {
    if (!theApp->Printer)
      theApp->Printer = new TPrinter(GetApplication());

    theApp->Printing++;

    TApxPreviewWin* prevW = new TApxPreviewWin(Parent, theApp->Printer,
                                  GetActiveMDIChild()->GetClientWindow(),
                                  _T("Print Preview"), new TLayoutWindow(0));
    prevW->Create();

    // Here we resize the preview window to take the size of the MainWindow, then
    // hide the MainWindow.
    //
    TFrameWindow * mainWindow =  GetApplication()->GetMainWindow();
    TRect r = mainWindow->GetWindowRect();
    prevW->MoveWindow(r);
    prevW->ShowWindow(SW_SHOWNORMAL);
    mainWindow->ShowWindow(SW_HIDE);

    GetApplication()->BeginModal(GetApplication()->GetMainWindow());

    // After the user closes the preview Window, we take its size and use it
    // to size the MainWindow, then show the MainWindow again.
    //
    r = prevW->GetWindowRect();
    mainWindow->MoveWindow(r);
    mainWindow->ShowWindow(SW_SHOWNORMAL);

    // We must destroy the preview window explicitly.  Otherwise, the window will
    // not be destroyed until it's parent the MainWindow is destroyed.
    //
    prevW->Destroy();
    delete prevW;

    theApp->Printing--;
  }
}


//--------------------------------------------------------
// TCEdMDIClient
// ~~~~~~~~~~
// Menu enabler used by Print, Print Setup and Print Preview.
//
void TCEdMDIClient::CmPrintEnable(TCommandEnabler& tce)
{
  if (GetActiveMDIChild()) {
    TCoolEditAppl* theApp = TYPESAFE_DOWNCAST(GetApplication(), TCoolEditAppl);
    if (theApp) {
      // If we have a Printer already created just test if all is okay.
      // Otherwise create a Printer object and make sure the printer really
      // exists and then delete the Printer object.
      //
      if (!theApp->Printer) {
        theApp->Printer = new TPrinter(theApp);
        tce.Enable(!theApp->Printer->GetSetup().Error);
      }
      else
        tce.Enable(!theApp->Printer->GetSetup().Error);
    }
  }
  else
    tce.Enable(false);
}


void TCEdMDIClient::EvDropFiles(TDropInfo)
{
  Parent->ForwardMessage();
}