//----------------------------------------------------------------------------
//  Project: Jurasic
//  OWL NExt
//  All rights reserved 1999
//
//  SUBSYSTEM:    Jurasic Application
//  FILE:         lang.cpp
//  AUTHOR:       Yura Bidus
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TParserSelector (GENERIC).
//  (Generated by OWL 6.0 Class Expert for VC version 1.5)
//----------------------------------------------------------------------------
#include "owlpch.h"
#include <coolprj/cooledit.h>
#include <coolprj/fpattern.h>

#include <coolprj/lang.h>


struct TSyntaxParserInfo {
	LPCTSTR        pattern;
	TParserCreator func;
};

extern TSyntaxParser* AsmParserCreator(TCoolTextWnd* parent);
extern TSyntaxParser* BasicParserCreator(TCoolTextWnd* parent);
extern TSyntaxParser* BatchParserCreator(TCoolTextWnd* parent);
extern TSyntaxParser* CParserCreator(TCoolTextWnd* parent);
extern TSyntaxParser* DclParserCreator(TCoolTextWnd* parent);
extern TSyntaxParser* FortranParserCreator(TCoolTextWnd* parent);
extern TSyntaxParser* HtmlParserCreator(TCoolTextWnd* parent);
extern TSyntaxParser* ISParserCreator(TCoolTextWnd* parent);
extern TSyntaxParser* JavaParserCreator(TCoolTextWnd* parent);
extern TSyntaxParser* LispParserCreator(TCoolTextWnd* parent);
extern TSyntaxParser* PascalParserCreator(TCoolTextWnd* parent);
extern TSyntaxParser* PerlParserCreator(TCoolTextWnd* parent);
extern TSyntaxParser* PlainTextParserCreator(TCoolTextWnd* parent);
extern TSyntaxParser* PythonParserCreator(TCoolTextWnd* parent);
extern TSyntaxParser* RexxParserCreator(TCoolTextWnd* parent);
extern TSyntaxParser* RsrcParserCreator(TCoolTextWnd* parent);
extern TSyntaxParser* SgmlParserCreator(TCoolTextWnd* parent);
extern TSyntaxParser* ShParserCreator(TCoolTextWnd* parent);
extern TSyntaxParser* SiodParserCreator(TCoolTextWnd* parent);
extern TSyntaxParser* SqlParserCreator(TCoolTextWnd* parent);
extern TSyntaxParser* TclParserCreator(TCoolTextWnd* parent);
extern TSyntaxParser* TexParserCreator(TCoolTextWnd* parent);


static TSyntaxParser* PlainTextParserCreator(TCoolTextWnd *parent)
{
	return new TPlainTextParser(parent);
}

TParserSelector::TParserInfo TParserSelector::ParserInfo [] = {
	{ "*.asm;*.inc;*.s",  (TParserCreator)AsmParserCreator, 0 },
	{ "*.bas;*.vb;*.vbs;*.frm;*.dsm",  (TParserCreator)BasicParserCreator, 0  },
	{ "*.bat;*.btm;*.cmd",  (TParserCreator)BatchParserCreator, 0  },
	{ "*.cpp;*.cxx;*.cc", (TParserCreator)CParserCreator, 0  },
	{ "*.c", (TParserCreator)CParserCreator, 0  },
	{ "*.h;*.hpp;*.hxx;*.inl;*.tlh;*.tli", (TParserCreator)CParserCreator, 0  },
	{ "*.dcl;*.dcc",  (TParserCreator)DclParserCreator, 0  },
	{ "*.f;*.f90;*.f9p;*.fpp;*.for",  (TParserCreator)FortranParserCreator, 0  },
	{ "*.html;*.htm;*.shtml",  (TParserCreator)HtmlParserCreator, 0  },
	{ "*.rul", (TParserCreator)ISParserCreator, 0  },
	{ "*.java;*.jav;*.js", (TParserCreator)JavaParserCreator, 0  },
	{ "*.lsp", (TParserCreator)LispParserCreator, 0  },
	{ "*.pas",  (TParserCreator)PascalParserCreator, 0  },
	{ "*.pl", (TParserCreator)PerlParserCreator, 0  },
	{ "*.txt;*.doc;*.diz",  (TParserCreator)PlainTextParserCreator, 0  },
	{ "*.py",  (TParserCreator)PythonParserCreator, 0  },
	{ "*.rex;*.rexx;*.cmd",  (TParserCreator)RexxParserCreator, 0  },
	{ "*.rc;*.dlg",  (TParserCreator)RsrcParserCreator, 0  },
	{ "*.sgml",  (TParserCreator)SgmlParserCreator, 0  },
	{ "*.sh;*.conf",  (TParserCreator)ShParserCreator, 0  },
	{ "*.scm",  (TParserCreator)SiodParserCreator, 0  },
	{ "*.sql",  (TParserCreator)SqlParserCreator, 0  },
	{ "*.tcl",  (TParserCreator)TclParserCreator, 0  },
	{ "*.tex;*.sty;*.cls;*.clo;*.ltx;*.fd;*.dtx",  (TParserCreator)TexParserCreator, 0  },
	{ "*.*",  (TParserCreator)PlainTextParserCreator, 0  }, // last any file
};

TParserSelector::TParserSelector(bool initDefTypes)
{
	if(initDefTypes){
		int count = COUNTOF(ParserInfo);
		for (int index = count-1; index >= 0; index--){
#if defined(BI_STD_RTL)
			Parsers.push_back(&ParserInfo[index]);
#else
			Parsers.Add(&ParserInfo[index]);
#endif
		}
	}
}
//
TParserSelector::~TParserSelector()
{
#if defined(BI_STD_RTL)
	for (int index = 0; index < Parsers.size(); index++){
#else
	for (int index = 0; index < Parsers.Size(); index++){
#endif
		if(Parsers[index]->Flags&pieDynamic){
			delete (LPTSTR)Parsers[index]->Pattern;
			delete Parsers[index];
		}
	}
}
//
bool TParserSelector::MatchFileType(LPCTSTR tplFilter, LPCTSTR path)
{
  // Make locale copy of filter
  //
  TAPointer<TCHAR> fltrCopy = nstrnewdup(tplFilter);
  LPTSTR fltr = fltrCopy;
  LPTSTR nxtFltr;

  // For each template, try each wilcard specified
  //
  while (fltr){
    // Is there another wildcard following - Null terminate at ';'
    //
    nxtFltr = _tcschr(fltr, _T(';'));
    if (nxtFltr)
      *nxtFltr++ = 0;
    if(fpattern_isvalid(fltr)){
			owl_string pattern;
			if(*fltr != _T('*'))
				pattern += _T('*');
			pattern += fltr;
			if(fpattern_matchn(pattern.c_str(), path))
        return true;
    }
    // Try next filter
    //
    fltr = (nxtFltr && *nxtFltr) ? nxtFltr : 0;
  }
  return false;
}
//
TParserSelector::TParserInfo* 
TParserSelector::MatchParser(LPCTSTR filename)
{
	if (filename==0 || _tcsrchr(filename, _T('.'))==0)
		return 0;

#if defined(BI_STD_RTL)
	for (int index = Parsers.size()-1; index >= 0; index--){
#else
	for (int index = Parsers.Size()-1; index >= 0; index--){
#endif
		if(MatchFileType(Parsers[index]->Pattern, filename))
			return Parsers[index];
	}
	return 0;
}
//
TSyntaxParser* 
TParserSelector::CreateParser(TCoolTextWnd* parent, LPCTSTR filename)
{
	TParserInfo* info = MatchParser(filename);
	if(!info)
		return PlainTextParserCreator(parent);
	return info->Func(parent);
}
//
void TParserSelector::AddParser(LPCTSTR pattern, TParserCreator func)
{
	TParserInfo* info = new TParserInfo;
	info->Pattern = nstrnewdup(pattern);
	info->Func    = func;
	info->Flags   = pieDynamic;

#if defined(BI_STD_RTL)
	Parsers.push_back(info);
#else
	Parsers.Add(info);
#endif
}
//
//TSyntaxParser* 
//ChooseSyntaxParser(TCoolTextWnd* parent, LPCTSTR filename)
//{
//	TParserSelector selector;
//	return selector.CreateParser(parent, filename);
//}
//