//----------------------------------------------------------------------------
//  Project Jurasic
//  OWL NExt
//  All rights reserved 1999
//
//  SUBSYSTEM:    Jurasic Application
//  FILE:         EditPropDlg.h
//  AUTHOR:       Yura Bidus
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TEditPropDlg (TPropertyPage).
//  (Generated by OWL 6.0 Class Expert for VC version 1.1)
//----------------------------------------------------------------------------
#if !defined(CLRPROPDLG_H) // Sentry, use file only if it's not already included.
#define CLRPROPDLG_H

#include <owl\propsht.h>
#include <owl\static.h>
#include <owl\combobox.h>
#include <owl\drawitem.h>
#include <owl\functor.h>
#include <coolprj/defs.h>

__OWL_DECLCLASS(TCheckBox);
__OWL_DECLCLASS(TListBox);
__OWL_DECLCLASS(TConfigFile);


//
// class TFontSample
// ~~~~~ ~~~~~~~~~~~
//
class _COOLCLASS TFontSample : public TStatic {
	public:
		TFontSample(TWindow*, int resId, TModule *module = 0);
		void		SetupWindow ();
		void		Paint (TDC&, bool, TRect&);
		void		SetTextColor(const TColor& clr);
		void		SetBkColor(const TColor& clr);
	private:
		TColor TextColor;
		TColor BkColor;
};

//
// class TFontDescr
// ~~~~~ ~~~~~~~~~~
//
class _COOLCLASS TFontDescr {
	public:
		TFontDescr();
		TFontDescr(int type, const LOGFONT& lf, int family);

		LPCSTR					GetName () const	  { return lf.lfFaceName; }
		int							GetType () const	  { return Type; }
		int							GetFamily () const	{ return Family; }
		const LOGFONT&	GetLogFont () const	{ return lf; }

		bool	operator<(const TFontDescr&) const;
		bool	operator==(const TFontDescr&) const;
	private:
		int			Type;
		int			Family;
		LOGFONT	lf;
};
//
// TFontList
// ~~~~~~~~~
//
typedef TSortedObjectArray<TFontDescr> TFontList;

//
class _COOLCLASS TODComboBox : public TComboBox {
	public:
		TODComboBox (TWindow* parent, int Id, int nLength, TModule* module = 0)
				: TComboBox (parent, Id, nLength, module) {}
	protected:
		virtual void DrawText(TDC& dc, TRect& rc, DRAWITEMSTRUCT& drawInfo) = 0;
	private:
		void DrawItem(DRAWITEMSTRUCT& drawInfo);
};

//
// class TFontNameList
// ~~~~~ ~~~~~~~~~~~~~
//
class _COOLCLASS TFontNameList : public TODComboBox{
	public:
    TFontNameList (TWindow* parent, int Id, TFontList& fonts, TModule* module = 0);
	protected:
		virtual void DrawText (TDC& dc, TRect& rc, DRAWITEMSTRUCT& drawInfo);

	private:
		TFontList&	Fontlist;
		TBitmap			BmpType;
};

//
// class TColorDrawItem
// ~~~~~ ~~~~~~~~~~~~~~
//
class _COOLCLASS TColorDrawItem: public TButtonTextDrawItem {
	public:
		TColorDrawItem(TDrawItemProxy* proxy, const TColor& color, const owl_string& text);
		virtual ~TColorDrawItem(){}
	
		const TColor& GetColor() const { return Color; }

		virtual void PaintBitmap(TDC& rc, TRect& rect);
		virtual void GetButtonSize(TSize& btnSize);

	protected:
		TColor Color;
};
//
// class TColorList
// ~~~~~ ~~~~~~~~~~
//
class _COOLCLASS TColorList : public TComboBox {
	public:
		TColorList (TWindow* parent, int Id, TModule* module = 0);
		~TColorList ();
		void AddDefColors();
		void SetupWindow();
		void SetProxy(TDrawItemProxy*	proxy);// must be called before SetupWindow
		void SetColor(const TColor& coor, const owl_string& text);
	protected:
		TDrawItemProxy*	Proxy;
};

typedef TTypedArray<TColor,TColor&,TStandardAllocator> TColorArray;


class _COOLCLASS TEditPropDlg;
//template <class R, class T1,class T2>  class TFunctor2;
// TPCallFunctor is a ptr to a fn taking 2 parameters and returns int
typedef TFunctor2<int,TEditPropDlg*,int> TPSheetFunctor;

#if defined(BI_HAS_MEMBER_TEMPLATE)
#	define TPSheet_FUNCTOR(func) TFunctionTranslator2<int,TEditPropDlg*,int,int (*)(TEditPropDlg*,int)>(func)
#	define TPSheet_MFUNCTOR(obj,memberFunc) TMemberTranslator2<int,TEditPropDlg*,int, int(obj::*)(TEditPropDlg*,int)>(obj, memberFunc);
#else
#	define TPSheet_FUNCTOR(func) Functor((TPSheetFunctor*)0, func)
#	define TPSheet_MFUNCTOR(obj,memberFunc) Functor((TPSheetFunctor*)0, obj, memberFunc)
#endif

/////////////////////////////////////////
//
//{{TPropertyPage = TEditPropDlg}}
//
// struct TEditPropDlgXfer
// ~~~~~~ ~~~~~~~~~~~~~~~~
//
//#include <pshpack1.h>
struct _COOLCLASS TEditPropDlgXfer{
	public:
		enum TCallType{ ctApply=0,ctReset,};
		
		TEditPropDlgXfer(const TPSheetFunctor& functor);

		void LoadData(TConfigFile* config);
		void SaveData(TConfigFile& config);

//{{TEditPropDlgXFER_DATA}}
		LOGFONT				LogFont;
		TColorArray		ColorText;
		TColorArray		ColorBk;
		TIntArray			ArrayBold;
		TIntArray			ArrayItalic;
		TIntArray			ArrayUnderline;
//{{TEditPropDlgXFER_DATA_END}}

		TPSheetFunctor Callback;//callback

	protected:
		bool           Dirty;   //internal variable
		friend class _COOLCLASS TEditPropDlg;
};
//#include <poppack.h>

//
// class TEditPropDlg
// ~~~~~ ~~~~~~~~~~~~
//
class _COOLCLASS TEditPropDlg: public TPropertyPage {
	typedef TPropertyPage Inherited;
  public:
    TEditPropDlg(TPropertySheet* parent, TEditPropDlgXfer& xfer, TResId iconRes = 0,TModule* module = 0);
    ~TEditPropDlg();


//{{TEditPropDlgVIRTUAL_BEGIN}}
	public:
		void SetupWindow();
//{{TEditPropDlgVIRTUAL_END}}

//{{TEditPropDlgXFER_DEF}}
	protected:
		TFontNameList*	Fontname;
		TComboBox*			Fontsize;
		TListBox*				Category;
		TColorList*			ColorText;
		TColorList*			ColorBk;
		TCheckBox*			Underline;
		TCheckBox*			Italic;
		TCheckBox*			Bold;
		TFontSample*		FontSample;
//{{TEditPropDlgXFER_DEF_END}}
	
	private:
		int GetSelItem (TComboBox* box);
		void FontSelected (TDC& dc, int index);
		void SinchronizeData();
		void SetClrtext(int index);
		void SetClrbk(int index);
		void SetFontsize();
		void PageChanged();
		void PageUnchanged();
			
	protected_data:
		TFontList					FontList;
		TFont*						SampleFont;
		TDrawItemProxy*		Proxy;
		TEditPropDlgXfer&	XFer;
		int               CyPixPerInch;
		//TCoolTextBuffer TextBuffer;
	
//{{TEditPropDlgRSP_TBL_BEGIN}}
	protected:
		void EvFontname();
		void EvFontsize();
		void EvClrtext();
		void EvClrbk();
		void EvCommandEditBold();
		void EvCommandEditItalic();
		void EvCommandEditUnderline();
		void EvSelchangeEditCategory();
		void EvMeasureItem(uint ctrlId, MEASUREITEMSTRUCT far& measureInfo);
    int  Apply(TNotify& not);
		void Reset(TNotify& not);
//{{TEditPropDlgRSP_TBL_END}}

	DECLARE_RESPONSE_TABLE(TEditPropDlg);
}; //{{TEditPropDlg}}


#endif  // CLRPROPDLG_H sentry.
