#if !defined(COOL_LANG_H)
#define COOL_LANG_H

#include <coolprj/cooledit.h>

#if defined(BI_STD_RTL)
#include <vector>
#else
#include <owl/template.h>
#endif

//
// class TParserSelector
// ~~~~~ ~~~~~~~~~~~~~~~
//
class _COOLCLASS TParserSelector {
	public:
		enum TParserInfoEnum{ pieNone, pieDynamic,};
		struct TParserInfo {
			LPCTSTR        Pattern;
			TParserCreator Func;
			uint           Flags;
		};
	public:
		TParserSelector(bool initDefTypes = true);
		~TParserSelector();
		static bool MatchFileType(LPCTSTR tplFilter, LPCTSTR path);
		
		TSyntaxParser* CreateParser(TCoolTextWnd* parent, LPCTSTR filename);
		TParserInfo*   MatchParser(LPCTSTR filename);

		void AddParser(LPCTSTR pattern, TParserCreator func);

	protected:
#if defined(BI_STD_RTL)
		typedef std::vector<TParserInfo*> TParserInfoArray;
#else
		typedef TPtrArray<TParserInfo*>		TParserInfoArray;
#endif
		TParserInfoArray Parsers;
	
		// default parsers
		static TParserInfo ParserInfo[];
};

// inline for now
inline TSyntaxParser* ChooseSyntaxParser(TCoolTextWnd* parent,LPCTSTR filename)
{
	TParserSelector selector;
	return selector.CreateParser(parent, filename);
}

#endif  // COOL_LANG_H sentry.
