//----------------------------------------------------------------------------
//  Project mdi
//  OWL NExt
//  Copyright 1999. All Rights reserved.
//
//  SUBSYSTEM:    mdi Application
//  FILE:         mdiapp.cpp
//  AUTHOR:       Yura
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TmdiAppl (TApplication).
//  (Generated by OWL 6.x Wizard for MS VC++. Version 1.5)
//----------------------------------------------------------------------------
#include "owlpch.h"


#include <owl/buttonga.h>
#include <owl/statusba.h>
#include <owl/cmdline.h>
#include <owl/registry.h>
#include <owl/functor.h>

#include "mdiapp.h"
#include "mdimdicl.h"
#include "mdiab.h"  // Definition of about dialog.

//{{TmdiAppl Implementation}}



//
// Build a response table for all messages/commands handled by the application.
//
DEFINE_RESPONSE_TABLE2(TmdiAppl, TRecentFiles, TApplication)
//{{TmdiApplRSP_TBL_BEGIN}}
  EV_COMMAND(CM_HELPABOUT, CmHelpAbout),
  EV_WM_DROPFILES,
  EV_WM_WININICHANGE,
  EV_REGISTERED(MruFileMessage, CmFileSelected),
//{{TmdiApplRSP_TBL_END}}
END_RESPONSE_TABLE;


//--------------------------------------------------------
// TmdiAppl
// ~~~~~
//
TmdiAppl::TmdiAppl() : TApplication(_T("mdi")), TRecentFiles(_T("Software\\OWL NExt\\mdi"), 4, 30, true)
{
  Printer = 0;
  Printing = 0;

  // INSERT>> Your constructor code here.
}


TmdiAppl::~TmdiAppl()
{
  delete Printer;

  // INSERT>> Your destructor code here.
}

//-------------------------------------------------------
// This is default implementaion of GadgetBuilder.
// You can delete this function and use default GadgetBuilder
// if you do not plan to castomize creation of gadgets.
//
static TGadget* UserGadgetBuilder(int index, int cmdId, bool& usecell)
{
  usecell = false;
  if(cmdId==0)
    return new TSeparatorGadget;
  usecell = true;
  return new TButtonGadget(index, cmdId, TButtonGadget::Command,false,TButtonGadget::Up,true);
}

//------------------------------------------------------------
// If you do not want customize Dockable bar creation you can  
// delete next function.
//
static TGadgetWindow* UserBarCreator(TWindow* frame)
{
  TDockableControlBar* cb = new TDockableControlBar(frame);

  // Add caption and fly-over help hints.
  //
  cb->SetCaption(_T("Toolbar"));
  cb->SetHintMode(TGadgetWindow::EnterHints);
  return cb;
}

bool TmdiAppl::UserBarInserter(TDecoratedFrame&, TGadgetWindow& destWindow, TAbsLocation loc)
{
  if(ApxHarbor->GetHandle())
    destWindow.Create();
  ApxHarbor->Insert((TDockableControlBar&)destWindow, loc);
  return true;
}

void TmdiAppl::SetupSpeedBar(TDecoratedMDIFrame* frame)
{

	TGadgetWindow::EnableFlatStyle();

  ApxHarbor = new THarbor(*frame);

  TBarDescr* barDescr = new TBarDescr(IDM_MDI);

  // You can delete this line and use default GadgetBuilder
  // if you do not plan to castomize gadgets
#if OWLInternalVersion > 0x06000720L
  barDescr->SetBuilder(TGadget_FUNCTOR(UserGadgetBuilder));
#else
  barDescr->GadgetBuilder = TGadget_FUNCTOR(UserGadgetBuilder);
#endif
  frame->SetBarDescr(barDescr);

  // If you do not want customize Dockable bar creation you can  
  // delete next line : frame->SetBarCreator(...)
#if OWLInternalVersion > 0x06000720L
  frame->SetBarCreator(TGadgetWnd_FUNCTOR(UserBarCreator));
  frame->SetBarInserter(TBarInsert_MFUNCTOR(*this,&TmdiAppl::UserBarInserter));
#else
  frame->BarCreator = TGadgetWnd_FUNCTOR(UserBarCreator);
  frame->EvBarInsert = TBarInsert_MFUNCTOR(*this,&TmdiAppl::UserBarInserter);
#endif

}

//--------------------------------------------------------
// TmdiAppl
// ~~~~~
// Application intialization.
//
void TmdiAppl::InitMainWindow()
{
  if (nCmdShow != SW_HIDE)
    nCmdShow = (nCmdShow != SW_SHOWMINNOACTIVE) ? SW_SHOWNORMAL : nCmdShow;

  MdiClient = new TmdiMDIClient;
  TDecoratedMDIFrame* frame = new TDecoratedMDIFrame(Name, IDM_MDI, *MdiClient, true);

  // Enable acceptance of dropped files
  //
  frame->ModifyExStyle(0,WS_EX_ACCEPTFILES);

  // Assign icons for this application.
  //
  frame->SetIcon(this, IDI_MDIAPPLICATION);
  frame->SetIconSm(this, IDI_MDIAPPLICATION);

  // Associate with the accelerator table.
  //
  frame->Attr.AccelTable = IDM_MDI;

  TStatusBar* sb = new TStatusBar(frame, TGadget::Recessed,
                                  TStatusBar::CapsLock        |
                                  TStatusBar::NumLock         |
                                  TStatusBar::ScrollLock      |
																	TStatusBar::SizeGrip);
  frame->Insert(*sb, TDecoratedFrame::Bottom);

  SetupSpeedBar(frame);

  SetMainWindow(frame);

  frame->SetMenuDescr(TMenuDescr(IDM_MDI));

}

//--------------------------------------------------------
// TmdiAppl
// ~~~~~
// Application instance initialization.
//
void TmdiAppl::InitInstance()
{
  TApplication::InitInstance();

  ProcessCmdLine(GetCmdLine().c_str());
}
//--------------------------------------------------------
// TmdiAppl
// ~~~~~
// Process command line parameters.
//
void TmdiAppl::ProcessCmdLine(LPCTSTR cmdLine)
{
  TCmdLine cmd(cmdLine);

  while (cmd.Kind != TCmdLine::Done) {
    if (cmd.Kind == TCmdLine::Option) {
      if (strnicmp(cmd.Token, "unregister", cmd.TokenLen) == 0) {
        UnRegisterInfo();
        return;
      }
    }
    cmd.NextToken();
  }

  RegisterInfo();
}


//--------------------------------------------------------
// TmdiAppl
// ~~~~~
// Register application info.
//
void TmdiAppl::RegisterInfo()
{
  TAPointer<_TCHAR> buffer = new _TCHAR[_MAX_PATH];

  GetModuleFileName(buffer, _MAX_PATH);

  TRegKey(TRegKey::GetClassesRoot(), _T("mdi.Application\\DefaultIcon")).SetDefValue(0, REG_SZ, buffer, _tcslen(buffer));
  _tcscat(buffer, _T(",1"));

  TRegKey(TRegKey::GetClassesRoot(), _T("mdi.Document.1\\DefaultIcon")).SetDefValue(0, REG_SZ, buffer, _tcslen(buffer));
  _tcscpy(buffer, "mdi.Document.1");
  TRegKey(TRegKey::GetClassesRoot(), _T(".txt")).SetDefValue(0, REG_SZ, buffer, _tcslen(buffer));
}


//--------------------------------------------------------
// TmdiAppl
// ~~~~~
// Unregister application info.
//
void TmdiAppl::UnRegisterInfo()
{
  TAPointer<_TCHAR> buffer = new _TCHAR[_MAX_PATH];

  GetModuleFileName(buffer, _MAX_PATH);

  TRegKey(TRegKey::GetClassesRoot(), _T("mdi.Application")).DeleteKey(_T("DefaultIcon"));
  TRegKey(TRegKey::GetClassesRoot(), _T("mdi.Document.1")).DeleteKey(_T("DefaultIcon"));

  TRegKey::ClassesRoot.DeleteKey(_T("mdi.Application"));
  TRegKey::ClassesRoot.DeleteKey(_T("mdi.Document.1"));
  TRegKey::ClassesRoot.DeleteKey(_T(".txt"));
}


//--------------------------------------------------------
// TmdiAppl
// ~~~~~~~~~~~
// Menu Help About mdi command
//
void TmdiAppl::CmHelpAbout()
{
  // Show the modal dialog.
  //
  TmdiAboutDlg(GetMainWindow()).Execute();
}

void TmdiAppl::EvDropFiles(TDropInfo drop)
{
  TFileDropletList files;

  // Iterate thru the entries in drop and create FileDrops objects for each
  // one.
  //
  int fileCount = drop.DragQueryFileCount();  // Number of files dropped.
  for (int i = 0; i < fileCount; i++)
    files.Add(new TFileDroplet(drop, i));

  // Open the files that were dropped.
  //
  AddFiles(files);

  // Release the memory allocated for this handle with DragFinish.
  //
  drop.DragFinish();
}

void TmdiAppl::AddFiles(TFileDropletList& files)
{
  TmdiMDIClient* theClient = TYPESAFE_DOWNCAST(GetMainWindow()->GetClientWindow(), TmdiMDIClient);

  if (theClient) {
    // Open all files dragged in.
    //
    for (TFileDropletListIter fileIter(files); fileIter; fileIter++)
      theClient->OpenFile((*fileIter)->GetName());
  }
}

int32 TmdiAppl::CmFileSelected(uint wp, int32)
{
  TAPointer<_TCHAR> text = new _TCHAR[_MAX_PATH];

  GetMenuText(wp, text, _MAX_PATH);

  TmdiMDIClient* theClient = TYPESAFE_DOWNCAST(GetMainWindow()->GetClientWindow(), TmdiMDIClient);

  if (theClient)
    theClient->OpenFile(text);
  return 0;
}

void TmdiAppl::EvWinIniChange(LPTSTR section)
{
  if (_tcscmp(section, "windows") == 0) {
    // If the device changed in the WIN.INI file then the printer
    // might have changed.  If we have a TPrinter(Printer) then
    // check and make sure it's identical to the current device
    // entry in WIN.INI.
    //
    if (Printer) {
      const int bufferSize = 255;
      _TCHAR printDBuffer[bufferSize];
      LPSTR printDevice = printDBuffer;
      LPSTR devName;
      LPSTR driverName = 0;
      LPSTR outputName = 0;
      if (::GetProfileString("windows", "device", "", printDevice, bufferSize)) {
        // The string which should come back is something like:
        //
        //      HP LaserJet III,hppcl5a,LPT1:
        //
        // Where the format is:
        //
        //      devName,driverName,outputName
        //
        devName = printDevice;
        while (*printDevice) {
          if (*printDevice == ',') {
            *printDevice++ = 0;
            if (!driverName)
              driverName = printDevice;
            else
              outputName = printDevice;
          }
          else
            printDevice = ::AnsiNext(printDevice);
        }

        if (Printer->GetSetup().Error != 0                ||
            strcmp(devName, Printer->GetSetup().GetDeviceName()) != 0  ||
            strcmp(driverName, Printer->GetSetup().GetDriverName()) != 0 ||
            strcmp(outputName, Printer->GetSetup().GetOutputName()) != 0 ) {
          // New printer installed so get the new printer device now.
          //
          delete Printer;
          Printer = new TPrinter(this);
        }
      }
      else {
        // No printer installed(GetProfileString failed).
        //
        delete Printer;
        Printer = new TPrinter(this);
      }
    }
  }
}

//-------------------------------------------------------------------
// OwlMain
// ~~~~~~~
// Application Start here.
//
int OwlMain(int , LPTSTR [])
{

  return TmdiAppl().Run();
}
