//----------------------------------------------------------------------------
//  Project mdi
//  OWL NExt
//  Copyright 1999. All Rights reserved.
//
//  SUBSYSTEM:    mdi Application
//  FILE:         mdiapp.h
//  AUTHOR:       Yura
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TmdiAppl (TApplication).
//  (Generated by OWL 6.0 Wizard for MS VC++. Version 1.5)
//----------------------------------------------------------------------------
#if !defined(mdiapp_h) // Sentry, use file only if it's not already included.
#define mdiapp_h

#include <owl/controlb.h>
#include <owl/docking.h>
#include <owl/opensave.h>
#include <owl/printer.h>
#include <owl/rcntfile.h>

#include "mdimdicl.h"
#include "resource.h"            // Definition of all resources.


//{{TApplication = TmdiAppl}}
class TmdiAppl : public TApplication, public TRecentFiles {
  private:

    bool UserBarInserter(TDecoratedFrame& frame, TGadgetWindow& destWindow, TAbsLocation loc);
    void SetupSpeedBar(TDecoratedMDIFrame* frame);
    void AddFiles(TFileDropletList& files);
    void ProcessCmdLine(LPCTSTR cmdLine);
    void RegisterInfo();
    void UnRegisterInfo();
  public:
    TmdiAppl();
    virtual ~TmdiAppl();

    TOpenSaveDialog::TData  FileData;                   // Data to control open/saveas standard dialog.
    TmdiMDIClient* MdiClient;
    THarbor*          ApxHarbor;

    // Public data members used by the print menu commands and Paint routine in MDIChild.
    //
    TPrinter*         Printer;                            // Printer support.
    int               Printing;                           // Printing in progress.

//{{TmdiApplVIRTUAL_BEGIN}}
  public:
    virtual void InitMainWindow();
    virtual void InitInstance();
//{{TmdiApplVIRTUAL_END}}

//{{TmdiApplRSP_TBL_BEGIN}}
  protected:
    void CmHelpAbout();
    void EvDropFiles(TDropInfo drop);
    void EvWinIniChange(LPTSTR section);
    int32 CmFileSelected(uint wp, int32 lp);
//{{TmdiApplRSP_TBL_END}}
        DECLARE_RESPONSE_TABLE(TmdiAppl);
};    //{{TmdiAppl}}


#endif  // mdiapp_h sentry.
