//----------------------------------------------------------------------------
//  Project coolgrid
//  OWL NExt
//  Copyright 1999 by Yura Bidus. All Rights reserved.
//
//  SUBSYSTEM:    coolgrid Application
//  FILE:         coolgridcl.cpp
//  AUTHOR:       Yura Bidus
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TCoolGridWindow (TWindow).
//  (Generated by OWL 6.x Wizard for MS VC++. Version 1.5)
//----------------------------------------------------------------------------
#include "owlpch.h"

#include "coolgridapp.h"
#include "coolgridmdicl.h"
#include "coolgridcl.h"

#include <stdio.h>



//////////////////////////////////////////////////////////////////////////////
static PALETTEENTRY gStaticColors[] = {
/*000*/	{  0,  0,  0,0},  // White
/*001*/	{128,  0,  0,0},  // Dark Red
/*002*/	{  0,128,  0,0},  // Dark Green
/*003*/	{128,128,  0,0},  // Dark Yellow
/*004*/	{  0,  0,128,0},  // Dark Blue 
/*005*/	{128,  0,128,0},  // Dark magenta
/*006*/	{  0,128,128,0},  // Dark Cyan
/*007*/	{192,192,192,0},  // Light Gray
/*008*/	{192,220,192,0},  // Money Gray
/*009*/	{166,202,240,0},  // Sky Blue

/*246*/	{255,251,240,0},  // Cream
/*247*/	{160,160,164,0},  // Light gray
/*248*/	{128,128,128,0},  // Medium Gray
/*249*/	{255,  0,  0,0},  // Red
/*250*/	{  0,255,  0,0},  // Green
/*251*/	{255,255,  0,0},  // Yellow
/*252*/	{  0,  0,255,0},  // Blue
/*253*/	{255,  0,255,0},  // Magenta
/*254*/	{  0,255,255,0},  // Cyan
/*255*/	{255,255,255,0},  // White 
};

class TColorCell: public TCoolGrid::TCell{
	typedef TCoolGrid::TCell Inherited;
	public:
		TColorCell(const TColor& color):Color(color){}

		virtual void Paint(TDC& dc, const TRect& rect);

	protected:
		TColor Color;
};
//
void TColorCell::Paint(TDC& dc, const TRect& rect)
{
	TColor oldClr = dc.SetBkColor(Color);
	dc.ExtTextOut(rect.TopLeft(), ETO_OPAQUE, &rect, _T(""), 0, 0);
	dc.SetBkColor(oldClr);
}

///////////////////////////////////////////////////////////////////////////////////


//{{TCoolGridWindow Implementation}}


//--------------------------------------------------------
// TCoolGridWindow
// ~~~~~~~~~~
// Construction/Destruction handling.
//
TCoolGridWindow::TCoolGridWindow(TWindow* parent, LPCTSTR title, TModule* module)
:
  TCoolGrid(parent,0,title,0,0,0,0,module)
{
  ModifyStyle(0, WS_VSCROLL|WS_HSCROLL);
  ModifyExStyle(0,WS_EX_CLIENTEDGE);
}
//
TCoolGridWindow::~TCoolGridWindow()
{
  Destroy();
}
//
///////////////////////////////////////////////////////////////////////////////////////
//
TCoolGridWnd1::TCoolGridWnd1(TWindow* parent, LPCTSTR, TModule* module)
:
  TCoolGridWindow(parent,_T("Color Grid"),module)
{
	SetGridDim(10, 10, 50);
	for(int i = 0; i < 10; i++){
		for(int j = 0; j < 10; j++)
			SetCell(TCellPos(i,j),*new TColorCell(gStaticColors[i+j]));
	}
}
///////////////////////////////////////////////////////////////////////////////////////
//
TCoolGridWnd2::TCoolGridWnd2(TWindow* parent, LPCTSTR, TModule* module)
:
  TCoolGridWindow(parent,_T("Text Grid"),module)
{
	SetGridDim(10, 10, 60);
	_TCHAR buffer[256];
	for(int i = 0; i < 10; i++){
		for(int j = 0; j < 10; j++){
			wsprintf(buffer, "Item(%d,%d)",i,j);
			SetCell(TCellPos(i,j), *new TTextCell(buffer));
		}
	}
}
///////////////////////////////////////////////////////////////////////////////////////
//
TCoolGridWnd3::TCoolGridWnd3(TWindow* parent, LPCTSTR, TModule* module)
:
  TCoolGridWindow(parent,_T("Edit Grid"),module)
{
	SetGridDim(10, 10, 80);
	SetInPlaceEdit(new TInPlaceEditCtrl(*this));
	_TCHAR buffer[256];
	for(int i = 0; i < 10; i++){
		for(int j = 0; j < 10; j++){
			wsprintf(buffer, "EditItem(%d,%d)",i,j);
			SetCell(TCellPos(i,j), *new TEditCell(buffer));
		}
	}
}
//
static TCoolGrid::TCell* CreateCoolCell(TCoolGrid&, const TCellPos&)
{
	return new TCoolGrid::TEditCell(_T(""));
}
///////////////////////////////////////////////////////////////////////////////////////
//
TCoolGridWnd4::TCoolGridWnd4(TWindow* parent, LPCTSTR, TModule* module)
:
  TCoolGridWindow(parent,"Dinamically Creatable Edit Grid", module)
{
	SetGridDim(10, 10, 80);
	SetCellBuilder(TCell_FUNCTOR(CreateCoolCell));
	SetInPlaceEdit(new TInPlaceEditCtrl(*this));
}
///////////////////////////////////////////////////////////////////////////////////////
//
TCoolGridWnd5::TCoolGridWnd5(TWindow* parent, LPCTSTR, TModule* module)
:
  TCoolGridWindow(parent,"DropDown List Grid", module)
{
	SetGridDim(10, 10, 80);
	
	_TCHAR buffer[256];
	
	// create InPlace ListBox and fill list items
	TInPlaceListBox* edit = new TInPlaceListBox(*this);
	for(int k = 0; k < 10; k++){
		wsprintf(buffer, "ListItem%d",k);
		edit->GetData().AddString(buffer, k == 0);
	}
	SetInPlaceEdit(edit);

	for(int i = 0; i < 10; i++){
		for(int j = 0; j < 10; j++){
			wsprintf(buffer, "ListItem%d",j);
			SetCell(TCellPos(i,j), *new TComboBoxCell(buffer));
		}
	}
}
///////////////////////////////////////////////////////////////////////////////////////
//
TCoolGridWnd6::TCoolGridWnd6(TWindow* parent, LPCTSTR, TModule* module)
:
  TCoolGridWindow(parent,"DropDown ComboBox Grid", module)
{
	SetGridDim(10, 10, 80);
	
	_TCHAR buffer[256];
	
	// create InPlace ListBox and fill list items
	TInPlaceListBox* edit = new TInPlaceComboBox(*this);
	for(int k = 0; k < 10; k++){
		wsprintf(buffer, "CBoxItem%d",k);
		edit->GetData().AddString(buffer, k == 0);
	}
	SetInPlaceEdit(edit);

	for(int i = 0; i < 10; i++){
		for(int j = 0; j < 10; j++){
			wsprintf(buffer, "CBoxItem%d",j);
			SetCell(TCellPos(i,j), *new TComboBoxCell(buffer));
		}
	}
}
///////////////////////////////////////////////////////////////////////////////////////
//
TCoolGridWnd7::TCoolGridWnd7(TWindow* parent, LPCTSTR, TModule* module)
:
  TCoolGridWindow(parent,"Mixed Grid", module)
{
	SetGridDim(10, 10, 50);
	
	_TCHAR buffer[256];
	int ColumnIndex = 0;
	TInPlaceListBox* ledit;
	TInPlaceComboBox* cedit;

#if 0
	for(int i = 0; i < 10; i++)
		SetCell(TCellPos(ColumnIndex,i),*new TColorCell(gStaticColors[i]));
	ColumnIndex++;
#endif

#if 0	
	SetColumnWidth(ColumnIndex, 70);
	for(int j = 0; j < 10; j++){
		wsprintf(buffer, "TextItem%d",j);
		SetCell(TCellPos(ColumnIndex,j), *new TTextCell(buffer));
	}
	ColumnIndex++;
#endif
	
#if 0
	SetColumnEdit(ColumnIndex, new TInPlaceEditCtrl(*this));
	SetColumnWidth(ColumnIndex, 80);
	for(int k = 0; k < 10; k++){
		wsprintf(buffer, "EditItem%d", k);
		SetCell(TCellPos(ColumnIndex, k), *new TEditCell(buffer));
	}
	ColumnIndex++;
#endif

#if 0
	ledit = new TInPlaceListBox(*this);
	ledit->GetData().AddString("ListItem0", true);
	ledit->GetData().AddString("ListItem1", true);
	ledit->GetData().AddString("ListItem2", false);
	ledit->GetData().AddString("ListItem4", false);
	ledit->GetData().AddString("ListItem5", false);
	ledit->GetData().AddString("ListItem6", false);
	ledit->GetData().AddString("ListItem7", false);
	ledit->GetData().AddString("ListItem8", false);
	ledit->GetData().AddString("ListItem9", false);

	SetColumnEdit(ColumnIndex, ledit);
	SetColumnWidth(ColumnIndex, 80);
	for(int l = 0; l < 10; l++){
		wsprintf(buffer, "ListItem%d", l);
		SetCell(TCellPos(ColumnIndex, l), *new TComboBoxCell(buffer));
	}
	ColumnIndex++;
#endif

#if 0
	cedit = new TInPlaceComboBox(*this);
	cedit->GetData().AddString("CBoxItem0", true);
	cedit->GetData().AddString("CBoxItem1", true);
	cedit->GetData().AddString("CBoxItem2", false);
	cedit->GetData().AddString("CBoxItem3", false);
	cedit->GetData().AddString("CBoxItem4", false);
	cedit->GetData().AddString("CBoxItem5", false);
	cedit->GetData().AddString("CBoxItem6", false);
	cedit->GetData().AddString("CBoxItem7", false);
	cedit->GetData().AddString("CBoxItem8", false);
	cedit->GetData().AddString("CBoxItem9", false);

	SetColumnEdit(ColumnIndex, cedit);
	SetColumnWidth(ColumnIndex, 80);
	for(int m = 0; m < 10; m++){
		wsprintf(buffer, "CBoxItem%d", m);
		SetCell(TCellPos(ColumnIndex, m), *new TComboBoxCell(buffer));
	}
	ColumnIndex++;
#endif

#if 1
	SetColumnWidth(ColumnIndex, 70);
	SetHorTitle(ColumnIndex, _T("Bool"));

	for(int n = 0; n < 10; n++){
		wsprintf(buffer, _T("bool %d"), n);
		SetCell(TCellPos(ColumnIndex, n), *new TTextCell(buffer));
		wsprintf(buffer, _T("Row #%d"), n);
		SetVertTitle(n, buffer);
	}
	ColumnIndex++;

	//cedit = new TInPlaceListBox(*this);
	cedit = new TInPlaceComboBox(*this);
	cedit->SetReadOnly(true);
	cedit->GetData().AddString(_T("true"), true);
	cedit->GetData().AddString(_T("false"), false);

	SetColumnEdit(ColumnIndex, cedit);
	SetColumnWidth(ColumnIndex, 60);
	SetHorTitle(ColumnIndex, _T("InplaceEdit"));

	for(int o = 0; o < 10; o++){
		TComboBoxCell* cell = new TComboBoxCell("true");
		cell->SetBgColor(TColor::LtGray);
		//cell->ShowButton(false);//for example not show buttons
		SetCell(TCellPos(ColumnIndex, o), *cell);
	}
	ColumnIndex++;
#endif

}
//////////////////////////////////////////
