//----------------------------------------------------------------------------
//  Project coolgrid
//  OWL NExt
//  Copyright 1999 by Yura Bidus. All Rights reserved.
//
//  SUBSYSTEM:    coolgrid Application
//  FILE:         coolgridmdicl.cpp
//  AUTHOR:       Yura Bidus
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TCoolGridMDIClient (TMDIClient).
//  (Generated by OWL 6.x Wizard for MS VC++. Version 1.5)
//----------------------------------------------------------------------------
#include "owlpch.h"

#include <owl/listbox.h>
#include <stdio.h>

#include "coolgridapp.h"
#include "coolgridcl.h"
#include "coolgridmdicl.h"
#include "coolgridmdich.h"



//{{TCoolGridMDIClient Implementation}}


//
// Build a response table for all messages/commands handled
// by TCoolGridMDIClient derived from TMDIClient.
//
DEFINE_RESPONSE_TABLE1(TCoolGridMDIClient, TMDIClient)
//{{TCoolGridMDIClientRSP_TBL_BEGIN}}
  EV_COMMAND(CM_FILECLOSE,  CmFileClose),
  EV_WM_DROPFILES,
	EV_COMMAND(CM_FILE_COLORGRID, CmFileColorgrid),
	EV_COMMAND(CM_FILE_TEXTGRID, CmFileTextgrid),
	EV_COMMAND(CM_FILE_EDITGRID, CmFileEditgrid),
	EV_COMMAND(CM_DILE_DEDITGRID, CmFileDeditgrid),
	EV_COMMAND(CM_FILE_DROPDOWNLIST, CmFileDropdownlist),
	EV_COMMAND(CM_FILE_COMBOBOX, CmFileCombobox),
	EV_COMMAND(CM_FILE_MIXED, CmFileMixed),
//{{TCoolGridMDIClientRSP_TBL_END}}
END_RESPONSE_TABLE;


//--------------------------------------------------------
// TCoolGridMDIClient
// ~~~~~~~~~~~
// Construction/Destruction handling.
//
TCoolGridMDIClient::TCoolGridMDIClient(TModule* module)
:
  TMDIClient(module),
  ChildCount(0)
{

  // INSERT>> Your constructor code here.

}


TCoolGridMDIClient::~TCoolGridMDIClient()
{
  Destroy();

  // INSERT>> Your destructor code here.

}


//--------------------------------------------------------
// TCoolGridMDIClient
// ~~~~~~~~~~~
// MDIClient site initialization.
//
void TCoolGridMDIClient::SetupWindow()
{
  // Default SetUpWindow processing.
  //
  TMDIClient::SetupWindow();
}


//
void TCoolGridMDIClient::SetupChild(TWindow* wnd)
{
	TTmpBuffer<_TCHAR> title(256);
	wsprintf(title,_T("%s - %d"),wnd->Title, ++ChildCount);
  TCoolGridChild* child = new TCoolGridChild(*this, title, wnd);

  // Assign icons for this child window.
  //
  child->SetIcon(GetApplication(), IDI_DOC);
  child->SetIconSm(GetApplication(), IDI_DOC);

  // If the current active MDI child is maximize then this one should be also.
  //
  TCoolGridChild* curChild = (TCoolGridChild*)GetActiveMDIChild();
  if (curChild && (curChild->GetWindowLong(GWL_STYLE) & WS_MAXIMIZE))
    child->ModifyStyle(0,WS_MAXIMIZE);

  child->Create();
}

//--------------------------------------------------------
// TCoolGridMDIClient
// ~~~~~~~~~~~
// Menu File Close command
//
void TCoolGridMDIClient::CmFileClose()
{
  TCoolGridChild* curChild = (TCoolGridChild*)GetActiveMDIChild();

  if (curChild) 
    curChild->CloseWindow();
}
//
void TCoolGridMDIClient::EvDropFiles(TDropInfo)
{
  Parent->ForwardMessage();
}
//
void TCoolGridMDIClient::CmFileColorgrid ()
{	
	SetupChild(new TCoolGridWnd1(this));
}
//
void TCoolGridMDIClient::CmFileTextgrid ()
{	
	SetupChild(new TCoolGridWnd2(this));
}
//
void TCoolGridMDIClient::CmFileEditgrid ()
{	
	SetupChild(new TCoolGridWnd3(this));
}
//
void TCoolGridMDIClient::CmFileDeditgrid ()
{	
	SetupChild(new TCoolGridWnd4(this));
}
//
void TCoolGridMDIClient::CmFileDropdownlist ()
{	
	SetupChild(new TCoolGridWnd5(this));
}
//
void TCoolGridMDIClient::CmFileCombobox ()
{	
	SetupChild(new TCoolGridWnd6(this));
}
//
void TCoolGridMDIClient::CmFileMixed ()
{	
	SetupChild(new TCoolGridWnd7(this));
}
//////////////////////////////////////////////////////
