//----------------------------------------------------------------------------
//  Project sdi
//  Some Company
//  Copyright 1999. All Rights reserved.
//
//  SUBSYSTEM:    sdi Application
//  FILE:         sdiab.cpp
//  AUTHOR:       Yura 
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TsdiAboutDlg (TDialog).
//  (Generated by OWL 6.0 Wizard for MS VC )
//----------------------------------------------------------------------------
#include "owlpch.h"

#include <owl/static.h>
#include <owl/tooltip.h>

#include "sdiapp.h"
#include "sdiab.h"  // Definition of about dialog.

//{{TsdiAboutDlg Implementation}}

//--------------------------------------------------------
// TsdiAboutDlg
// ~~~~~~~~~~
// Construction/Destruction handling.
//
TsdiAboutDlg::TsdiAboutDlg(TWindow* parent, TResId resId, TModule* module)
:
  TDialog(parent, resId, module)
{
  // INSERT>> Your constructor code here.
}


TsdiAboutDlg::~TsdiAboutDlg()
{
  Destroy();

  // INSERT>> Your destructor code here.
}


void TsdiAboutDlg::SetupWindow()
{
  LPSTR prodName = 0, prodVersion = 0, copyright = 0, debug = 0;

  // Get the static text for the value based on VERSIONINFO.
  //
  TStatic* versionCtrl = new TStatic(this, IDC_VERSION, 255);
  TStatic* copyrightCtrl = new TStatic(this, IDC_COPYRIGHT, 255);
  TStatic* debugCtrl = new TStatic(this, IDC_DEBUG, 255);

  TDialog::SetupWindow();

  // Process the VERSIONINFO.
  //
	TModuleVersionInfo applVersion(*GetModule());

  // Get the product name and product version strings.
  //
  if (applVersion.GetProductName(prodName) && applVersion.GetProductVersion(prodVersion)) {
    // IDC_VERSION is the product name and version number, the initial value of IDC_VERSION is
    // the word Version(in whatever language) product name VERSION product version.
    //
    _TCHAR buffer[255];
    _TCHAR versionName[128];

    buffer[0] = _T('\0');
    versionName[0] = _T('\0');

    versionCtrl->GetText(versionName, sizeof versionName);
    wsprintf(buffer, _T("%s %s %s"), prodName, versionName, prodVersion);

    versionCtrl->SetText(buffer);
  }

  // Get the legal copyright string.
  //
  if (applVersion.GetLegalCopyright(copyright))
    copyrightCtrl->SetText(copyright);

  // Only get the SpecialBuild text if the VERSIONINFO resource is there.
  //
  if (applVersion.GetSpecialBuild(debug))
    debugCtrl->SetText(debug);

  TsdiAppl* theApp = TYPESAFE_DOWNCAST(GetApplication(), TsdiAppl);
	TTooltip* tooltip = theApp->GetTooltip();
  TWindow* mainWnd = theApp->GetMainWindow();

	{		
		//TToolInfo toolInfo(mainWnd->GetHandle(), versionCtrl->GetHandle());
		TRect rect;
 		versionCtrl->GetClientRect(rect);
		TToolInfo toolInfo(*versionCtrl, rect, IDC_VERSION);
		toolInfo.SetText("versionCtrl");
		tooltip->AddTool(toolInfo);
	}
	{		
		//TToolInfo toolInfo(mainWnd->GetHandle(), copyrightCtrl->GetHandle());
		TRect rect;
 		copyrightCtrl->GetClientRect(rect);
		TToolInfo toolInfo(*copyrightCtrl, rect, IDC_COPYRIGHT);
		toolInfo.SetText("copyrightCtrl");
		tooltip->AddTool(toolInfo);
	}
	{		
		//TToolInfo toolInfo(mainWnd->GetHandle(), debugCtrl->GetHandle());
		TRect rect;
 		debugCtrl->GetClientRect(rect);
		TToolInfo toolInfo(*debugCtrl, rect, IDC_DEBUG);
		toolInfo.SetText("debugCtrl");
		tooltip->AddTool(toolInfo);
	}
	tooltip->Activate();
}
//
bool TsdiAboutDlg::PreProcessMsg(MSG& msg)
{	
  // Check if this message might be worth relaying to the tooltip window
  //
  TTooltip* tooltip = TYPESAFE_DOWNCAST(GetApplication(), TsdiAppl)->GetTooltip();
  if (tooltip && tooltip->IsWindow()) {
    if (msg.hwnd == *this || IsChild(msg.hwnd)) {
      if (msg.message >= WM_MOUSEFIRST && msg.message <= WM_MOUSELAST) {
        tooltip->RelayEvent(msg);
      }
    }
  }
	// Call base class function.
	return TDialog::PreProcessMsg(msg);
}
//=====================================================================================
