//----------------------------------------------------------------------------
//  Project sdi
//  Some Company
//  Copyright 1999. All Rights reserved.
//
//  SUBSYSTEM:    sdi Application
//  FILE:         sdiapp.cpp
//  AUTHOR:       Yura
//
//  OVERVIEW 
//  ~~~~~~~~
//  Source file for implementation of TsdiAppl (TApplication).
//  (Generated by OWL 6.0 Wizard for MS VC )
//----------------------------------------------------------------------------
#include "owlpch.h"

#include <owl/cmdline.h>
#include <owl/registry.h>
#include <owl/statusba.h>
#include <owl/textgadg.h>
#include <owl/bitmapga.h>
#include "sdiapp.h"
#include "sdicl.h" // Definition of client class.
#include "sdiab.h"  // Definition of about dialog.
#include "lang.h"

// ID_LINEINDICATOR

////////////////////////////////////////////////////
//
//{{TsdiAppl Implementation}}

//
// Build a response table for all messages/commands handled
// by the application.
//
DEFINE_RESPONSE_TABLE2(TsdiAppl, TRecentFiles, TApplication)
//{{TsdiApplRSP_TBL_BEGIN}}
  EV_COMMAND(CM_FILENEW, CmFileNew),
  EV_COMMAND(CM_FILEOPEN, CmFileOpen),
  EV_COMMAND(CM_HELPABOUT, CmHelpAbout),
  EV_REGISTERED(MruFileMessage, CmFileSelected),
//{{TsdiApplRSP_TBL_END}}
END_RESPONSE_TABLE;


//--------------------------------------------------------
// TsdiAppl
//

TsdiAppl::TsdiAppl() 
: 
	TApplication(_T("sdi")), 
	TRecentFiles(_T("Software\\OWL NExt\\sdi"), 4, 30, true)
{

  // Common file file flags and filters for Open/Save As dialogs.  Filename and directory are
  // computed in the member functions CmFileOpen, and CmFileSaveAs.
  //
  FileData.Flags |= OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
  FileData.SetFilter(_T("All Files (*.*)|*.*|"));
  FileData.DefExt = _T("txt");
  // INSERT>> Your constructor code here.
}

TsdiAppl::~TsdiAppl()
{
  // INSERT>> Your destructor code here.
}

//--------------------------------------------------------
// TsdiAppl
// ~~~~~
// Application intialization.
//
void TsdiAppl::InitMainWindow()
{
  if (nCmdShow != SW_HIDE)
    nCmdShow = (nCmdShow != SW_SHOWMINNOACTIVE) ? SW_SHOWNORMAL : nCmdShow;

  TSDIFrameWindow* frame = new TSDIFrameWindow(0, GetName(), 0, true);

  // Assign icons for this application.
  //
  frame->SetIcon(this, IDI_SDIAPPLICATION);
  frame->SetIconSm(this, IDI_SDIAPPLICATION);

  // Associate with the accelerator table.
  //
  frame->Attr.AccelTable = IDM_SDI;

  SetMainWindow(frame);

  // Menu associated with window.
  //
  frame->SetMenuDescr(TMenuDescr(IDM_SDI));

	TStatusBar* sb = new TStatusBar(frame, TGadget::Recessed,
																	TStatusBar::CapsLock        |
																	TStatusBar::NumLock         |
																	TStatusBar::SizeGrip,
																	new TDefaultGUIFont);

	// ID_LINEINDICATOR
	TGadget* textGadget = 
		new TDynamicTextGadget(ID_LINEINDICATOR, TTextGadget::Recessed, 
		                       TTextGadget::Left, 4);
	sb->Insert(*textGadget);
	// ID_DIRTYINDICATOR
	TGadget* bmpGadget = 
		new TDynamicBitmapGadget(ID_DIRTYINDICATOR, ID_DIRTYINDICATOR, 
		                         TTextGadget::Recessed, 3);
	sb->Insert(*bmpGadget, TStatusBar::Before);
	//ID_INSERTINDICATOR
	textGadget = new TDynamicTextGadget(ID_INSERTINDICATOR, 
		           TTextGadget::Recessed, TTextGadget::Left, 2);
	TGadget* gd = sb->GadgetWithId(IDG_STATUS_NUM);
	sb->Insert(*textGadget,TStatusBar::After, gd);

  frame->Insert(*sb, TDecoratedFrame::Bottom);
}
//--------------------------------------------------------
// TsdiAppl
// ~~~~~
// Application instance initialization.
//
void TsdiAppl::InitInstance()
{
  TApplication::InitInstance();

  ProcessCmdLine(GetCmdLine().c_str());
}

//--------------------------------------------------------
// TsdiAppl
// ~~~~~
// Process command line parameters.
//
void TsdiAppl::ProcessCmdLine(LPCTSTR CmdLine)
{
  TCmdLine cmd(CmdLine);

  while (cmd.Kind != TCmdLine::Done) {
    if (cmd.Kind == TCmdLine::Option) {
      if (strnicmp(cmd.Token, "unregister", cmd.TokenLen) == 0) {
        UnRegisterInfo();
        return;
      }
    }
    cmd.NextToken();
  }

  RegisterInfo();
}


//--------------------------------------------------------
// TsdiAppl
// ~~~~~
// Register application info.
//
void TsdiAppl::RegisterInfo()
{
  TAPointer<TCHAR> buffer = new TCHAR[_MAX_PATH];

  GetModuleFileName(buffer, _MAX_PATH);

  TRegKey(TRegKey::GetClassesRoot(), _T("sdi.Application\\DefaultIcon")).SetDefValue(0, REG_SZ, buffer, _tcslen(buffer));
  _tcscat(buffer, _T(",1"));

  TRegKey(TRegKey::GetClassesRoot(), _T("sdi.Document.1\\DefaultIcon")).SetDefValue(0, REG_SZ, buffer, _tcslen(buffer));
  strcpy(buffer, "sdi.Document.1");
  TRegKey(TRegKey::GetClassesRoot(), _T(".txt")).SetDefValue(0, REG_SZ, buffer, _tcslen(buffer));
}


//--------------------------------------------------------
// TsdiAppl
// ~~~~~
// Unregister application info.
//
void TsdiAppl::UnRegisterInfo()
{
  TAPointer<_TCHAR> buffer = new _TCHAR[_MAX_PATH];

  GetModuleFileName(buffer, _MAX_PATH);

  TRegKey(TRegKey::GetClassesRoot(), _T("sdi.Application")).DeleteKey(_T("DefaultIcon"));
  TRegKey(TRegKey::GetClassesRoot(), _T("sdi.Document.1")).DeleteKey(_T("DefaultIcon"));

  TRegKey::ClassesRoot.DeleteKey(_T("sdi.Application"));
  TRegKey::ClassesRoot.DeleteKey(_T("sdi.Document.1"));
  TRegKey::ClassesRoot.DeleteKey(_T(".txt"));
}


//--------------------------------------------------------
// TsdiAppl
// ~~~~~~~~~~~
// Menu File New command
//
void TsdiAppl::CmFileNew()
{
  TsdiWindow* client = TYPESAFE_DOWNCAST(GetMainWindow()->GetClientWindow(),
                             TsdiWindow);     // Client window for the frame.
  client->FileNew();
}


//------------------------------------------------------------------------------
// TsdiAppl
// ~~~~~~~~~~~
// Menu File Open command
//
void TsdiAppl::CmFileOpen()
{
  // Display standard Open dialog box to select a file name.
  //
  *FileData.FileName = 0;

  TsdiWindow* client = TYPESAFE_DOWNCAST(GetMainWindow()->GetClientWindow(),
                             TsdiWindow);     // Client window for the frame.
  if (client->CanClose())
    if (TFileOpenDialog(GetMainWindow(), FileData).Execute() == IDOK)
      OpenFile();
}
//
void TsdiAppl::OpenFile(LPCTSTR fileName)
{
  if (fileName)
    _tcscpy(FileData.FileName, fileName);

  TsdiWindow* client = TYPESAFE_DOWNCAST(GetMainWindow()->GetClientWindow(), TsdiWindow);     // Client window for the frame.
  if(!client->FileOpen(FileData.FileName)){
		RemoveMenuChoice(FileData.FileName);
		return;
	}
	client->SetSyntaxParser(ChooseSyntaxParser(client,FileData.FileName));

  // Add the file to the MRU list.
  //
  SaveMenuChoice(FileData.FileName);
}


//{{TSDIFrameWindow Implementation}}


TSDIFrameWindow::TSDIFrameWindow(TWindow* parent, LPCTSTR title, TWindow* clientWnd, bool trackMenuSelection, TModule* module)
:
  TDecoratedFrame(parent, title, !clientWnd ? new TsdiWindow(0, 0, 0) : clientWnd, trackMenuSelection, module)
{
  // INSERT>> Your constructor code here.
}
//
TSDIFrameWindow::~TSDIFrameWindow()
{
  // INSERT>> Your destructor code here.
}
//


//--------------------------------------------------------
// TsdiAppl
// ~~~~~~~~~~~
// Menu Help About sdi command
//
void TsdiAppl::CmHelpAbout()
{
  // Show the modal dialog.
  //
  TsdiAboutDlg(GetMainWindow()).Execute();
}


int32 TsdiAppl::CmFileSelected(uint wp, int32)
{
  TAPointer<_TCHAR> text = new _TCHAR[MAX_PATH];

  GetMenuText(wp, text, MAX_PATH);

  OpenFile(text);
  return 0;
}

//-------------------------------------------------------------------
// OwlMain
// ~~~~~~~
// Application Start here.
//
int OwlMain(int , LPTSTR [])
{

  return TsdiAppl().Run();
}
//
