//----------------------------------------------------------------------------
//  Project sdi
//  Some Company
//  Copyright 1999. All Rights reserved.
//
//  SUBSYSTEM:    sdi Application
//  FILE:         sdiapp.h
//  AUTHOR:       Yura
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TsdiAppl (TApplication).
//  (Generated by OWL 6.0 Wizard for VC.)
//----------------------------------------------------------------------------
#if !defined(sdiapp_h)              // Sentry, use file only if it's not already included.
#define sdiapp_h


#include <owl/opensave.h>
#include <owl/rcntfile.h>

#include "resource.h"            // Definition of all resources.

__OWL_BEGIN_NAMESPACE
class _OWLCLASS TTooltip;
__OWL_END_NAMESPACE

//
// FrameWindow must be derived to override Paint for Preview and Print.
//
//{{TDecoratedFrame = TSDIFrameWindow}}
class TSDIFrameWindow : public TDecoratedFrame {
  public:
    TSDIFrameWindow(TWindow* parent, LPCTSTR title, TWindow* clientWnd, bool trackMenuSelection = false, TModule* module = 0);
    ~TSDIFrameWindow();
};    //{{TSDIFrameWindow}}

//{{TApplication = TsdiAppl}}
class TsdiAppl : public TApplication, public TRecentFiles {
  private:
    void ProcessCmdLine(LPCTSTR cmdLine);
    void RegisterInfo();
    void UnRegisterInfo();

		TTooltip* Tooltip;

  public:
    TsdiAppl();
    virtual ~TsdiAppl();

		TTooltip* GetTooltip() { return Tooltip; }


    void OpenFile(LPCTSTR fileName = 0);

    TOpenSaveDialog::TData FileData;  // Data to control open/saveas standard dialog.


//{{TsdiApplVIRTUAL_BEGIN}}
  public:
    virtual void InitMainWindow();
    virtual void InitInstance();
//		virtual bool ProcessAppMsg(MSG& msg);
//{{TsdiApplVIRTUAL_END}}

//{{TsdiApplRSP_TBL_BEGIN}}
  protected:
    void CmFileNew();
    void CmFileOpen();
    void CmHelpAbout();
    int32 CmFileSelected(uint wp, int32 lp);
//{{TsdiApplRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TsdiAppl);
};    //{{TsdiAppl}}


#endif  // sdiapp_h sentry.

