//----------------------------------------------------------------------------
//  Project sdidv
//  OWL NExt
//  Copyright 1999. All Rights reserved.
//
//  SUBSYSTEM:    sdidv Application
//  FILE:         sdidvab.cpp
//  AUTHOR:       Yura Bidus
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TsdidvAppl (TApplication).
//  (Generated by OWL 6.x Wizard for MS VC++. Version 1.5)
//----------------------------------------------------------------------------
#include "owlpch.h"

#include <owl/static.h>

#include "sdidvapp.h"
#include "sdidvab.h"  // Definition of about dialog.

//{{TsdidvAboutDlg Implementation}}

//--------------------------------------------------------
// TsdidvAboutDlg
// ~~~~~~~~~~
// Construction/Destruction handling.
//
TsdidvAboutDlg::TsdidvAboutDlg(TWindow* parent, TResId resId, TModule* module)
:
  TDialog(parent, resId, module)
{
  // INSERT>> Your constructor code here.
}


TsdidvAboutDlg::~TsdidvAboutDlg()
{
  Destroy();

  // INSERT>> Your destructor code here.
}


void TsdidvAboutDlg::SetupWindow()
{
  LPSTR prodName = 0, prodVersion = 0, copyright = 0, debug = 0;

  // Get the static text for the value based on VERSIONINFO.
  //
  TStatic* versionCtrl = new TStatic(this, IDC_VERSION, 255);
  TStatic* copyrightCtrl = new TStatic(this, IDC_COPYRIGHT, 255);
  TStatic* debugCtrl = new TStatic(this, IDC_DEBUG, 255);

  TDialog::SetupWindow();

  // Process the VERSIONINFO.
  //
	TModuleVersionInfo applVersion(*GetModule());

  // Get the product name and product version strings.
  //
  if (applVersion.GetProductName(prodName) && applVersion.GetProductVersion(prodVersion)) {
    // IDC_VERSION is the product name and version number, the initial value of IDC_VERSION is
    // the word Version(in whatever language) product name VERSION product version.
    //
    _TCHAR buffer[255];
    _TCHAR versionName[128];

    buffer[0] = _T('\0');
    versionName[0] = _T('\0');

    versionCtrl->GetText(versionName, sizeof versionName);
    wsprintf(buffer, _T("%s %s %s"), prodName, versionName, prodVersion);

    versionCtrl->SetText(buffer);
  }

  // Get the legal copyright string.
  //
  if (applVersion.GetLegalCopyright(copyright))
    copyrightCtrl->SetText(copyright);

  // Only get the SpecialBuild text if the VERSIONINFO resource is there.
  //
  if (applVersion.GetSpecialBuild(debug))
    debugCtrl->SetText(debug);
}
//=====================================================================================