//----------------------------------------------------------------------------
//  Project sdidv
//  OWL NExt
//  Copyright 1999. All Rights reserved.
//
//  SUBSYSTEM:    sdidv Application
//  FILE:         sdidvapp.cpp
//  AUTHOR:       Yura Bidus
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TsdidvAppl (TApplication).
//  (Generated by OWL 6.x Wizard for MS VC++. Version 1.5)
//----------------------------------------------------------------------------
#include "owlpch.h"

#include <owl/docmanag.h>
#include <owl/statusba.h>
#include <owl/filedoc.h>
#include <owl/cmdline.h>

#include <owl/textgadg.h>
#include <owl/bitmapga.h>
#include "cooldoc.h"

#include "sdidvapp.h"
#include "sdidvcl.h" // Definition of client class.
#include "sdidvab.h"  // Definition of about dialog.

TSyntaxParser* AsmParserCreator(TCoolTextWnd* parent);
TSyntaxParser* BasicParserCreator(TCoolTextWnd* parent);
TSyntaxParser* BatchParserCreator(TCoolTextWnd* parent);
TSyntaxParser* CParserCreator(TCoolTextWnd* parent);
TSyntaxParser* DclParserCreator(TCoolTextWnd* parent);
TSyntaxParser* FortranParserCreator(TCoolTextWnd* parent);
TSyntaxParser* HtmlParserCreator(TCoolTextWnd* parent);
TSyntaxParser* ISParserCreator(TCoolTextWnd* parent);
TSyntaxParser* JavaParserCreator(TCoolTextWnd* parent);
TSyntaxParser* LispParserCreator(TCoolTextWnd* parent);
TSyntaxParser* PascalParserCreator(TCoolTextWnd* parent);
TSyntaxParser* PerlParserCreator(TCoolTextWnd* parent);
TSyntaxParser* PlainTextParserCreator(TCoolTextWnd* parent);
TSyntaxParser* PythonParserCreator(TCoolTextWnd* parent);
TSyntaxParser* RexxParserCreator(TCoolTextWnd* parent);
TSyntaxParser* RsrcParserCreator(TCoolTextWnd* parent);
TSyntaxParser* SgmlParserCreator(TCoolTextWnd* parent);
TSyntaxParser* ShParserCreator(TCoolTextWnd* parent);
TSyntaxParser* SiodParserCreator(TCoolTextWnd* parent);
TSyntaxParser* SqlParserCreator(TCoolTextWnd* parent);
TSyntaxParser* TclParserCreator(TCoolTextWnd* parent);
TSyntaxParser* TexParserCreator(TCoolTextWnd* parent);

static TSyntaxParser* PlainTextParserCreator(TCoolTextWnd *parent)
{
	return new TPlainTextParser(parent);
}

//{{TsdidvAppl Implementation}}

REGISTRATION_FORMAT_BUFFER(200)

//{{DOC_VIEW}}
DEFINE_DOC_TEMPLATE_CLASS(TCoolDocument, TsdidvView, DocType1);
//{{DOC_VIEW_END}}

//{{DOC_MANAGER}}
BEGIN_REGISTRATION(TCoolEditViewReg0)
	REGDATA(description,_T("Assembler Files"))
	REGDATA(extension,  _T("asm"))
	REGDATA(docfilter,  _T("*.asm;*.inc"))
	REGDOCFLAGS(dtAutoDelete|dtUpdateDir|dtOverwritePrompt|dtAutoOpen)
	REGCOOLPARSER(AsmParserCreator)
	REGICON(IDI_SDIAPPLICATION)
END_REGISTRATION
DocType1 __dvt0(TCoolEditViewReg0);

BEGIN_REGISTRATION(TCoolEditViewReg1)
	REGDATA(description,_T("Basic Files"))
	REGDATA(extension,  _T("bas"))
	REGDATA(docfilter,  _T("*.vb;*.vbs;*.frm;*.dsm"))
	REGICON(IDI_SDIAPPLICATION)
	REGCOOLPARSER(BasicParserCreator)
	REGDOCFLAGS(dtAutoDelete|dtUpdateDir|dtOverwritePrompt|dtAutoOpen)
END_REGISTRATION
DocType1 __dvt1(TCoolEditViewReg1);

BEGIN_REGISTRATION(TCoolEditViewReg2)
	REGDATA(description,_T("Batch Files"))
	REGDATA(extension,  _T("bat"))
	REGDATA(docfilter,  _T("*.bat;*.btm;*.cmd"))
	REGICON(IDI_SDIAPPLICATION)
	REGCOOLPARSER(BatchParserCreator)
	REGDOCFLAGS(dtAutoDelete|dtUpdateDir|dtOverwritePrompt|dtAutoOpen)
END_REGISTRATION
DocType1 __dvt2(TCoolEditViewReg2);

BEGIN_REGISTRATION(TCoolEditViewReg3)
	REGDATA(description,_T("C++ Source Files"))
	REGDATA(extension,  _T("cpp"))
	REGDATA(docfilter,  _T("*.cpp;*.cxx;*.cc"))
	REGICON(IDI_SDIAPPLICATION)
	REGCOOLPARSER(CParserCreator)
	REGDOCFLAGS(dtAutoDelete|dtUpdateDir|dtOverwritePrompt|dtAutoOpen)
END_REGISTRATION
DocType1 __dvt3(TCoolEditViewReg3);

BEGIN_REGISTRATION(TCoolEditViewReg4)
	REGDATA(description,_T("C Source Files"))
	REGDATA(extension,  _T("c"))
	REGDATA(docfilter,  _T("*.c"))
	REGICON(IDI_SDIAPPLICATION)
	REGCOOLPARSER(CParserCreator)
	REGDOCFLAGS(dtAutoDelete|dtUpdateDir|dtOverwritePrompt|dtAutoOpen)
END_REGISTRATION
DocType1 __dvt4(TCoolEditViewReg4);

BEGIN_REGISTRATION(TCoolEditViewReg5)
	REGDATA(description,_T("Include Files"))
	REGDATA(extension,  _T("h"))
	REGDATA(docfilter,  _T("*.h;*.hpp;*.hxx;*.inl;*.tlh;*.tli"))
	REGICON(IDI_SDIAPPLICATION)
	REGCOOLPARSER(CParserCreator)
	REGDOCFLAGS(dtAutoDelete|dtUpdateDir|dtOverwritePrompt|dtAutoOpen)
END_REGISTRATION
DocType1 __dvt5(TCoolEditViewReg5);

BEGIN_REGISTRATION(TCoolEditViewReg6)
	REGDATA(description,_T("DCL Files"))
	REGDATA(extension,  _T("dcl"))
	REGDATA(docfilter,  _T("*.dcl;*.dcc"))
	REGICON(IDI_SDIAPPLICATION)
	REGCOOLPARSER(DclParserCreator)
	REGDOCFLAGS(dtAutoDelete|dtUpdateDir|dtOverwritePrompt|dtAutoOpen)
END_REGISTRATION
DocType1 __dvt6(TCoolEditViewReg6);

BEGIN_REGISTRATION(TCoolEditViewReg7)
	REGDATA(description,_T("Fortran Files"))
	REGDATA(extension,  _T("for"))
	REGDATA(docfilter,  _T("*.f;*.f90;*.f9p;*.fpp;*.for"))
	REGICON(IDI_SDIAPPLICATION)
	REGCOOLPARSER(FortranParserCreator)
	REGDOCFLAGS(dtAutoDelete|dtUpdateDir|dtOverwritePrompt|dtAutoOpen)
END_REGISTRATION
DocType1 __dvt7(TCoolEditViewReg7);

BEGIN_REGISTRATION(TCoolEditViewReg8)
	REGDATA(description,_T("HTML Files"))
	REGDATA(extension,  _T("htm"))
	REGDATA(docfilter,  _T("*.html;*.htm;*.shtml"))
	REGICON(IDI_SDIAPPLICATION)
	REGCOOLPARSER(HtmlParserCreator)
	REGDOCFLAGS(dtAutoDelete|dtUpdateDir|dtOverwritePrompt|dtAutoOpen)
END_REGISTRATION
DocType1 __dvt8(TCoolEditViewReg8);

BEGIN_REGISTRATION(TCoolEditViewReg9)
	REGDATA(description,_T("InstallShield Files"))
	REGDATA(extension,  _T("rul"))
	REGDATA(docfilter,  _T("*.rul"))
	REGICON(IDI_SDIAPPLICATION)
	REGCOOLPARSER(ISParserCreator)
	REGDOCFLAGS(dtAutoDelete|dtUpdateDir|dtOverwritePrompt|dtAutoOpen)
END_REGISTRATION
DocType1 __dvt9(TCoolEditViewReg9);

BEGIN_REGISTRATION(TCoolEditViewReg10)
	REGDATA(description,_T("Java Files"))
	REGDATA(extension,  _T("java"))
	REGDATA(docfilter,  _T("*.java;*.jav;*.js"))
	REGICON(IDI_SDIAPPLICATION)
	REGCOOLPARSER(JavaParserCreator)
	REGDOCFLAGS(dtAutoDelete|dtUpdateDir|dtOverwritePrompt|dtAutoOpen)
END_REGISTRATION
DocType1 __dvt10(TCoolEditViewReg10);

BEGIN_REGISTRATION(TCoolEditViewReg11)
	REGDATA(description,_T("AutoLISP Files"))
	REGDATA(extension,  _T("lsp"))
	REGDATA(docfilter,  _T("*.lsp"))
	REGICON(IDI_SDIAPPLICATION)
	REGCOOLPARSER(LispParserCreator)
	REGDOCFLAGS(dtAutoDelete|dtUpdateDir|dtOverwritePrompt|dtAutoOpen)
END_REGISTRATION
DocType1  __dvt11(TCoolEditViewReg11);

BEGIN_REGISTRATION(TCoolEditViewReg12)
	REGDATA(description,_T("Pascal Files"))
	REGDATA(extension,  _T("pas"))
	REGDATA(docfilter,  _T("*.pas"))
	REGDOCFLAGS(dtAutoDelete|dtUpdateDir|dtOverwritePrompt|dtAutoOpen)
	REGICON(IDI_SDIAPPLICATION)
	REGCOOLPARSER(PascalParserCreator)
END_REGISTRATION
DocType1  __dvt12(TCoolEditViewReg12);

BEGIN_REGISTRATION(TCoolEditViewReg13)
	REGDATA(description,_T("Perl Files"))
	REGDATA(extension,  _T("pl"))
	REGDATA(docfilter,  _T("*.pl"))
	REGDOCFLAGS(dtAutoDelete|dtUpdateDir|dtOverwritePrompt|dtAutoOpen)
	REGICON(IDI_SDIAPPLICATION)
	REGCOOLPARSER(PerlParserCreator)
END_REGISTRATION
DocType1  __dvt13(TCoolEditViewReg13);

BEGIN_REGISTRATION(TCoolEditViewReg14)
	REGDATA(description,_T("Plain Text Files"))
	REGDATA(extension,  _T("txt"))
	REGDATA(docfilter,  _T("*.txt;*.doc;*.diz"))
	REGDOCFLAGS(dtAutoDelete|dtUpdateDir|dtOverwritePrompt|dtAutoOpen)
	REGICON(IDI_SDIAPPLICATION)
	REGCOOLPARSER(PlainTextParserCreator)
END_REGISTRATION
DocType1  __dvt14(TCoolEditViewReg14);

BEGIN_REGISTRATION(TCoolEditViewReg15)
	REGDATA(description,_T("Python Files"))
	REGDATA(extension,  _T("py"))
	REGDATA(docfilter,  _T("*.py"))
	REGDOCFLAGS(dtAutoDelete|dtUpdateDir|dtOverwritePrompt|dtAutoOpen)
	REGICON(IDI_SDIAPPLICATION)
	REGCOOLPARSER(PythonParserCreator)
END_REGISTRATION
DocType1  __dvt15(TCoolEditViewReg15);

BEGIN_REGISTRATION(TCoolEditViewReg16)
	REGDATA(description,_T("REXX Files"))
	REGDATA(extension,  _T("java"))
	REGDATA(docfilter,  _T("*.rex;*.rexx;*.cmd"))
	REGDOCFLAGS(dtAutoDelete|dtUpdateDir|dtOverwritePrompt|dtAutoOpen)
	REGICON(IDI_SDIAPPLICATION)
	REGCOOLPARSER(RexxParserCreator)
END_REGISTRATION
DocType1  __dvt16(TCoolEditViewReg16);

BEGIN_REGISTRATION(TCoolEditViewReg17)
	REGDATA(description,_T("Resources Files"))
	REGDATA(extension,  _T("rc"))
	REGDATA(docfilter,  _T("*.rc;*.dlg"))
	REGDOCFLAGS(dtAutoDelete|dtUpdateDir|dtOverwritePrompt|dtAutoOpen)
	REGICON(IDI_SDIAPPLICATION)
	REGCOOLPARSER(RsrcParserCreator)
END_REGISTRATION
DocType1  __dvt17(TCoolEditViewReg17);

BEGIN_REGISTRATION(TCoolEditViewReg18)
	REGDATA(description,_T("Sgml Files"))
	REGDATA(extension,  _T("sgml"))
	REGDATA(docfilter,  _T("*.sgml"))
	REGDOCFLAGS(dtAutoDelete|dtUpdateDir|dtOverwritePrompt|dtAutoOpen)
	REGICON(IDI_SDIAPPLICATION)
	REGCOOLPARSER(SgmlParserCreator)
END_REGISTRATION
DocType1  __dvt18(TCoolEditViewReg18);

BEGIN_REGISTRATION(TCoolEditViewReg19)
	REGDATA(description,_T("Shell Files"))
	REGDATA(extension,  _T("sh"))
	REGDATA(docfilter,  _T("*.sh;*.conf"))
	REGDOCFLAGS(dtAutoDelete|dtUpdateDir|dtOverwritePrompt|dtAutoOpen)
	REGICON(IDI_SDIAPPLICATION)
	REGCOOLPARSER(ShParserCreator)
END_REGISTRATION
DocType1  __dvt19(TCoolEditViewReg19);

BEGIN_REGISTRATION(TCoolEditViewReg20)
	REGDATA(description,_T("SIOD Files"))
	REGDATA(extension,  _T("scm"))
	REGDATA(docfilter,  _T("*.scm"))
	REGDOCFLAGS(dtAutoDelete|dtUpdateDir|dtOverwritePrompt|dtAutoOpen)
	REGICON(IDI_SDIAPPLICATION)
	REGCOOLPARSER(SiodParserCreator)
END_REGISTRATION
DocType1  __dvt20(TCoolEditViewReg20);

BEGIN_REGISTRATION(TCoolEditViewReg21)
	REGDATA(description,_T("SQL Files"))
	REGDATA(extension,  _T("sql"))
	REGDATA(docfilter,  _T("*.sql"))
	REGDOCFLAGS(dtAutoDelete|dtUpdateDir|dtOverwritePrompt|dtAutoOpen)
	REGICON(IDI_SDIAPPLICATION)
	REGCOOLPARSER(SqlParserCreator)
END_REGISTRATION
DocType1  __dvt21(TCoolEditViewReg21);

BEGIN_REGISTRATION(TCoolEditViewReg22)
	REGDATA(description,_T("TCL Files"))
	REGDATA(extension,  _T("tcl"))
	REGDATA(docfilter,  _T("*.tcl"))
	REGDOCFLAGS(dtAutoDelete|dtUpdateDir|dtOverwritePrompt|dtAutoOpen)
	REGICON(IDI_SDIAPPLICATION)
	REGCOOLPARSER(TclParserCreator)
END_REGISTRATION
DocType1  __dvt22(TCoolEditViewReg22);

BEGIN_REGISTRATION(TCoolEditViewReg23)
	REGDATA(description,_T("TEX Files"))
	REGDATA(extension,  _T("tex"))
	REGDATA(docfilter,  _T("*.tex;*.sty;*.cls;*.clo;*.ltx;*.fd;*.dtx"))
	REGDOCFLAGS(dtAutoDelete|dtUpdateDir|dtOverwritePrompt|dtAutoOpen)
	REGICON(IDI_SDIAPPLICATION)
	REGCOOLPARSER(TexParserCreator)
END_REGISTRATION
DocType1  __dvt23(TCoolEditViewReg23);

BEGIN_REGISTRATION(TCoolEditViewReg24)
	REGDATA(description,_T("All Files"))
	REGDATA(extension,  _T("txt"))
	REGDATA(docfilter,  _T("*.*"))
	REGICON(IDI_SDIAPPLICATION)
	REGCOOLPARSER(PlainTextParserCreator)
	REGDOCFLAGS(dtAutoDelete|dtUpdateDir|dtOverwritePrompt|dtAutoOpen)
END_REGISTRATION
DocType1 __dvt24(TCoolEditViewReg24);

//{{DOC_MANAGER_END}}



//
// Build a response table for all messages/commands handled by the application.
//
DEFINE_RESPONSE_TABLE2(TsdidvAppl, TRecentFiles, TApplication)
//{{TsdidvApplRSP_TBL_BEGIN}}
  EV_OWLVIEW(dnCreate, EvNewView),
  EV_OWLVIEW(dnClose,  EvCloseView),
  EV_COMMAND(CM_HELPABOUT, CmHelpAbout),
  EV_COMMAND(CM_FILEPRINT, CmFilePrint),
  EV_COMMAND(CM_FILEPRINTERSETUP, CmFilePrintSetup),
  EV_COMMAND(CM_FILEPRINTPREVIEW, CmFilePrintPreview),
  EV_COMMAND_ENABLE(CM_FILEPRINT, CmPrintEnable),
  EV_COMMAND_ENABLE(CM_FILEPRINTERSETUP, CmPrintEnable),
  EV_COMMAND_ENABLE(CM_FILEPRINTPREVIEW, CmPrintEnable),
  EV_WM_DROPFILES,
  EV_WM_WININICHANGE,
  EV_OWLDOCUMENT(dnCreate, EvOwlDocument),
  EV_OWLDOCUMENT(dnRename, EvOwlDocument),
  EV_REGISTERED(MruFileMessage, CmFileSelected),
//{{TsdidvApplRSP_TBL_END}}
END_RESPONSE_TABLE;


//--------------------------------------------------------
// TsdidvAppl
// ~~~~~
//
TsdidvAppl::TsdidvAppl() : TApplication(_T("sdidv")), TRecentFiles(_T("Software\\OWL NExt\\sdidv"), 4, 30, true)
{

  Printer = 0;
  Printing = 0;

  SetDocManager(new TDocManager(dmSDI, this));
  // INSERT>> Your constructor code here.

}


TsdidvAppl::~TsdidvAppl()
{
  delete Printer;
  // INSERT>> Your destructor code here.

}

//--------------------------------------------------------
// TsdidvAppl
// ~~~~~
// Application main window construction & intialization.
//
void TsdidvAppl::InitMainWindow()
{
  if (nCmdShow != SW_HIDE)
    nCmdShow = (nCmdShow != SW_SHOWMINNOACTIVE) ? SW_SHOWNORMAL : nCmdShow;

  TSDIDecFrame* frame = new TSDIDecFrame(0, GetName(), 0, true, this);


  // Enable acceptance of dropped files
  //
  frame->ModifyExStyle(0,WS_EX_ACCEPTFILES);

  // Assign icons for this application.
  //
  frame->SetIcon(this, IDI_SDIAPPLICATION);
  frame->SetIconSm(this, IDI_SDIAPPLICATION);

  // Menu associated with window and accelerator table associated with table.
  //
  frame->AssignMenu(IDM_SDI);

  // Associate with the accelerator table.
  //
  frame->Attr.AccelTable = IDM_SDI;

  TStatusBar* sb = new TStatusBar(frame, TGadget::Recessed,
																	TStatusBar::CapsLock        |
																	TStatusBar::NumLock         |
																	TStatusBar::Overtype        |
																	TStatusBar::ExtendSelection |
																	TStatusBar::SizeGrip);
  frame->Insert(*sb, TDecoratedFrame::Bottom);

	TGadget* textGadget = 
		new TDynamicTextGadget(ID_LINEINDICATOR, TTextGadget::Recessed, 
		                       TTextGadget::Left, 8);
	sb->Insert(*textGadget);
	TGadget* bmpGadget = 
		new TDynamicBitmapGadget(ID_DIRTYINDICATOR, ID_DIRTYINDICATOR, 
		                         TTextGadget::Recessed, 3);
	sb->Insert(*bmpGadget, TStatusBar::Before);

  SetMainWindow(frame);

  frame->SetMenuDescr(TMenuDescr(IDM_SDI));

}

//--------------------------------------------------------
// TsdidvAppl
// ~~~~~
// Application instance initialization.
//
void TsdidvAppl::InitInstance()
{
  TApplication::InitInstance();
  GetDocManager()->CreateAnyDoc(0, dtNewDoc);
  ProcessCmdLine(GetCmdLine().c_str());
}
//--------------------------------------------------------
// TsdidvAppl
// ~~~~~
// Process command line parameters.
//
void TsdidvAppl::ProcessCmdLine(LPCTSTR cmdLine)
{
  TCmdLine cmd(cmdLine);

  while (cmd.Kind != TCmdLine::Done) {
    if (cmd.Kind == TCmdLine::Option) {
      if (strnicmp(cmd.Token, "unregister", cmd.TokenLen) == 0) {
        UnRegisterInfo();
        return;
      }
    }
    cmd.NextToken();
  }

  RegisterInfo();
}


//--------------------------------------------------------
// TsdidvAppl
// ~~~~~
// Register application info.
//
void TsdidvAppl::RegisterInfo()
{
  TAPointer<_TCHAR> buffer = new _TCHAR[_MAX_PATH];

  GetModuleFileName(buffer, _MAX_PATH);

  TRegKey(TRegKey::GetClassesRoot(), _T("sdidv.Application\\DefaultIcon")).SetDefValue(0, REG_SZ, buffer, _tcslen(buffer));
  _tcscat(buffer, _T(",1"));

  TRegKey(TRegKey::GetClassesRoot(), _T("sdidv.Document.1\\DefaultIcon")).SetDefValue(0, REG_SZ, buffer, _tcslen(buffer));
  _tcscpy(buffer, "sdidv.Document.1");
  TRegKey(TRegKey::GetClassesRoot(), _T(".txt")).SetDefValue(0, REG_SZ, buffer, _tcslen(buffer));
}


//--------------------------------------------------------
// TsdidvAppl
// ~~~~~
// Unregister application info.
//
void TsdidvAppl::UnRegisterInfo()
{
  TAPointer<_TCHAR> buffer = new _TCHAR[_MAX_PATH];

  GetModuleFileName(buffer, _MAX_PATH);

  TRegKey(TRegKey::GetClassesRoot(), _T("sdidv.Application")).DeleteKey(_T("DefaultIcon"));
  TRegKey(TRegKey::GetClassesRoot(), _T("sdidv.Document.1")).DeleteKey(_T("DefaultIcon"));

  TRegKey::ClassesRoot.DeleteKey(_T("sdidv.Application"));
  TRegKey::ClassesRoot.DeleteKey(_T("sdidv.Document.1"));
  TRegKey::ClassesRoot.DeleteKey(_T(".txt"));
}

//--------------------------------------------------------
// TsdidvAppl
// ~~~~~
// Response Table handlers:
//
void TsdidvAppl::EvNewView(TView& view)
{
  GetMainWindow()->SetClientWindow(view.GetWindow());
  if (!view.IsOK())
    GetMainWindow()->SetClientWindow(0);
  else{
	  if (view.GetViewMenu())
      GetMainWindow()->MergeMenu(*view.GetViewMenu());
  }

  // Assign icons with this child window.??????
//  int iconIdx = _ttol(view.GetDocument().GetTemplate()->GetRegList()["iconindex"]);
//  GetMainWindow()->SetIcon(this, iconIdx);
//  GetMainWindow()->SetIconSm(this, iconIdx);
}
//
void TsdidvAppl::EvCloseView(TView&)
{
  GetMainWindow()->SetClientWindow(0);
  GetMainWindow()->SetCaption(_T("CoolEdit Example - sdidv"));
}


//{{TSDIDecFrame Implementation}}


TSDIDecFrame::TSDIDecFrame(TWindow* parent, LPCTSTR title, TWindow* clientWnd, bool trackMenuSelection, TModule* module)
:
  TDecoratedFrame(parent, title, clientWnd, trackMenuSelection, module)
{
  // INSERT>> Your constructor code here.

}


TSDIDecFrame::~TSDIDecFrame()
{
  // INSERT>> Your destructor code here.

}


//--------------------------------------------------------
// TsdidvAppl
// ~~~~~~~~~~
// Menu File Print command
//
void TsdidvAppl::CmFilePrint()
{
  // Create Printer object if not already created.
  //
  if (!Printer)
    Printer = new TPrinter(this);

  TDocument* currentDoc = GetDocManager()->GetCurrentDoc();

  TAPointer<_TCHAR> docName = new _TCHAR[_MAX_PATH];

  if (currentDoc->GetTitle())
    _tcscpy(docName, currentDoc->GetTitle());
  else
    _tcscpy(docName, _T("Document"));

  // Create Printout window and set characteristics.
  //
  TApxPrintout printout(Printer, docName, GetMainWindow()->GetClientWindow());
  printout.SetBanding(true);

  Printing++;

  // Bring up the Print dialog and print the document.
  //
  Printer->Print(GetWindowPtr(GetActiveWindow()), printout, true);

  Printing--;
}


//--------------------------------------------------------
// TsdidvAppl
// ~~~~~~~~~~
// Menu File Print Setup command
//
void TsdidvAppl::CmFilePrintSetup()
{
  if (!Printer)
    Printer = new TPrinter(this);

  // Bring up the Print Setup dialog.
  //
  Printer->Setup(GetMainWindow());
}


//--------------------------------------------------------
// TsdidvAppl
// ~~~~~~~~~~
// Menu File Print Preview command
//
void TsdidvAppl::CmFilePrintPreview()
{
  TSDIDecFrame* sdiFrame = TYPESAFE_DOWNCAST(GetMainWindow(), TSDIDecFrame);
  if (sdiFrame) {
    if (!Printer)
      Printer = new TPrinter(this);

    Printing++;

    TApxPreviewWin* prevW = new TApxPreviewWin(sdiFrame, Printer, sdiFrame->GetClientWindow(), "Print Preview", new TLayoutWindow(0));
    prevW->Create();

    // Here we resize the preview window to take the size of the MainWindow, then
    // hide the MainWindow.
    //
    TFrameWindow * mainWindow =  GetMainWindow();
    TRect r = mainWindow->GetWindowRect();
    prevW->MoveWindow(r);
    prevW->ShowWindow(SW_SHOWNORMAL);
    mainWindow->ShowWindow(SW_HIDE);

    BeginModal(GetMainWindow());

    // After the user closes the preview Window, we take its size and use it
    // to size the MainWindow, then show the MainWindow again.
    //
    r = prevW->GetWindowRect();
    mainWindow->MoveWindow(r);
    mainWindow->ShowWindow(SW_SHOWNORMAL);

    Printing--;

    // Now that printing is off we can invalidate because the edit window to repaint.
    //
    GetMainWindow()->SetRedraw(true);
    GetMainWindow()->Invalidate();

    // We must destroy the preview window explicitly.  Otherwise, the window will
    // not be destroyed until it's parent the MainWindow is destroyed.
    //
    prevW->Destroy();
    delete prevW;
  }
}


//--------------------------------------------------------
// TsdidvAppl
// ~~~~~~~~~~
// Menu enabler used by Print, Print Setup and Print Preview.
//
void TsdidvAppl::CmPrintEnable(TCommandEnabler& tce)
{
  // If we have a Printer already created just test if all is okay.
  // Otherwise create a Printer object and make sure the printer really exists
  // and then delete the Printer object.
  //
  if (!Printer) {
    Printer = new TPrinter(this);
      tce.Enable(!Printer->GetSetup().Error);
  }
  else
    tce.Enable(!Printer->GetSetup().Error);
}


//--------------------------------------------------------
// TsdidvAppl
// ~~~~~~~~~~~
//
// Menu Help About sdidv command
void TsdidvAppl::CmHelpAbout()
{
  // Show the modal dialog.
  //
  TsdidvAboutDlg(GetMainWindow()).Execute();
}


void TsdidvAppl::EvDropFiles(TDropInfo drop)
{
  // Tell DragQueryFile the file interested in (0) and the length of your buffer.
  //
  int			nameLength = drop.DragQueryFileNameLen(0) + 1;
  _TCHAR* fileName = new _TCHAR[nameLength];

  drop.DragQueryFile(0, fileName, nameLength);

  // Open the file that was dropped.
  //
  AddFile(fileName);

  // Release the memory allocated for this handle with DragFinish.
  //
  drop.DragFinish();
  delete[] fileName;
}


void TsdidvAppl::AddFile(const _TCHAR* fileName)
{
  TDocTemplate* tpl = GetDocManager()->MatchTemplate(fileName);
  if (tpl)
    GetDocManager()->CreateDoc(tpl, fileName);
}


void TsdidvAppl::EvOwlDocument(TDocument& doc)
{
  if (doc.GetDocPath())
    SaveMenuChoice(doc.GetDocPath());
}


int32 TsdidvAppl::CmFileSelected(uint wp, int32)
{
  TAPointer<_TCHAR> text = new _TCHAR[_MAX_PATH];

  GetMenuText(wp, text, _MAX_PATH);
  TDocTemplate* tpl = GetDocManager()->MatchTemplate(text);
  if (tpl)
    GetDocManager()->CreateDoc(tpl, text);
  return 0;
}

void TsdidvAppl::EvWinIniChange(LPTSTR section)
{
  if (_tcscmp(section, "windows") == 0) {
    // If the device changed in the WIN.INI file then the printer
    // might have changed.  If we have a TPrinter(Printer) then
    // check and make sure it's identical to the current device
    // entry in WIN.INI.
    //
    if (Printer) {
      const int bufferSize = 255;
      _TCHAR printDBuffer[bufferSize];
      LPSTR printDevice = printDBuffer;
      LPSTR devName;
      LPSTR driverName = 0;
      LPSTR outputName = 0;
      if (::GetProfileString("windows", "device", "", printDevice, bufferSize)) {
        // The string which should come back is something like:
        //
        //      HP LaserJet III,hppcl5a,LPT1:
        //
        // Where the format is:
        //
        //      devName,driverName,outputName
        //
        devName = printDevice;
        while (*printDevice) {
          if (*printDevice == ',') {
            *printDevice++ = 0;
            if (!driverName)
              driverName = printDevice;
            else
              outputName = printDevice;
          }
          else
            printDevice = ::AnsiNext(printDevice);
        }

        if (Printer->GetSetup().Error != 0                ||
            strcmp(devName, Printer->GetSetup().GetDeviceName()) != 0  ||
            strcmp(driverName, Printer->GetSetup().GetDriverName()) != 0 ||
            strcmp(outputName, Printer->GetSetup().GetOutputName()) != 0 ) {
          // New printer installed so get the new printer device now.
          //
          delete Printer;
          Printer = new TPrinter(this);
        }
      }
      else {
        // No printer installed(GetProfileString failed).
        //
        delete Printer;
        Printer = new TPrinter(this);
      }
    }
  }
}

//-------------------------------------------------------------------
// OwlMain
// ~~~~~~~
// Application Start here.
//
int OwlMain(int , LPTSTR [])
{
  return TsdidvAppl().Run();
}
//
