//----------------------------------------------------------------------------
//  Project sdidv
//  OWL NExt
//  Copyright 1999. All Rights reserved.
//
//  SUBSYSTEM:    sdidv Application
//  FILE:         sdidvapp.h
//  AUTHOR:       Yura Bidus
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TsdidvAppl (TApplication).
//  (Generated by OWL 6.0 Wizard for MS VC++. Version 1.5)
//----------------------------------------------------------------------------
#if !defined(sdidvapp_h) // Sentry, use file only if it's not already included.
#define sdidvapp_h

#include <owl/printer.h>
#include <owl/rcntfile.h>

#include "apxprint.h"
#include "apxprev.h"

#include "resource.h"            // Definition of all resources.


//
// FrameWindow must be derived to override Paint for Preview and Print.
//
//{{TDecoratedFrame = TSDIDecFrame}}
class TSDIDecFrame : public TDecoratedFrame {
  public:
    TSDIDecFrame(TWindow* parent, LPCTSTR title, TWindow* clientWnd, bool trackMenuSelection = false, TModule* module = 0);
    ~TSDIDecFrame();

};    //{{TSDIDecFrame}}

//{{TApplication = TsdidvAppl}}
class TsdidvAppl : public TApplication, public TRecentFiles {
  private:
  private:
    void AddFile(LPCSTR fileName);
    void ProcessCmdLine(LPCTSTR cmdLine);
    void RegisterInfo();
    void UnRegisterInfo();

  public:
    TsdidvAppl();
    virtual ~TsdidvAppl();

    // Public data members used by the print menu commands and Paint routine in MDIChild.
    //
    TPrinter*       Printer;                            // Printer support.
    int             Printing;                           // Printing in progress.

//{{TsdidvApplVIRTUAL_BEGIN}}
  public:
    virtual void InitMainWindow();
    virtual void InitInstance();
//{{TsdidvApplVIRTUAL_END}}

//{{TsdidvApplRSP_TBL_BEGIN}}
  protected:
    void EvNewView(TView& view);
    void EvCloseView(TView& view);
    void CmHelpAbout();
    void CmFilePrint();
    void CmFilePrintSetup();
    void CmFilePrintPreview();
    void CmPrintEnable(TCommandEnabler& tce);
    void EvDropFiles(TDropInfo drop);
    void EvWinIniChange(LPTSTR section);
    void EvOwlDocument(TDocument& doc);
    int32 CmFileSelected(uint wp, int32 lp);
//{{TsdidvApplRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TsdidvAppl);
};    //{{TsdidvAppl}}


#endif  // sdidvapp_h sentry.
