//----------------------------------------------------------------------------
//  Project sdidv
//  OWL NExt
//  Copyright 1999. All Rights reserved.
//
//  SUBSYSTEM:    sdidv Application
//  FILE:         sdidvcl.cpp
//  AUTHOR:       Yura Bidus
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TsdidvView (TCoolEdit).
//  (Generated by OWL 6.x Wizard for MS VC++. Version 1.5)
//----------------------------------------------------------------------------
#include "owlpch.h"
#include <owl/choosefo.h>

#include "sdidvapp.h"
#include "sdidvcl.h"
#include "cooldoc.h"

#include <stdio.h>


//{{TsdidvView Implementation}}


//
// Build a response table for all messages/commands handled
// by TsdidvView derived from TEditView.
//
DEFINE_RESPONSE_TABLE1(TsdidvView, TCoolEditView)
//{{TsdidvViewRSP_TBL_BEGIN}}
  EV_WM_GETMINMAXINFO,
	EV_COMMAND(CM_EDITCLEAR_BOOKMARKS,			CmEditClearBookmarks),
	EV_COMMAND(CM_EDITTOGGLE_BOOKMARK,			CmEditToggleBookmark),
	EV_COMMAND(CM_EDITGOTO_NEXT_BOOKMARK,		CmEditGotoNextBookmark),
	EV_COMMAND(CM_EDITGOTO_PREV_BOOKMARK,		CmEditGotoPrevBookmark),
	EV_COMMAND(CM_EDITCLEAR_ALL_BOOKMARKS,	CmEditClearAllBookmarks),
	EV_COMMAND(CM_EDITREADONLY,							CmEditReadonly),
	EV_COMMAND_ENABLE(CM_EDITREADONLY,			CeEditReadonly),

	EV_COMMAND_AND_ID(CM_EDITGO_BOOKMARK0, 	CmEditGotoRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITGO_BOOKMARK1, 	CmEditGotoRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITGO_BOOKMARK2, 	CmEditGotoRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITGO_BOOKMARK3, 	CmEditGotoRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITGO_BOOKMARK4, 	CmEditGotoRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITGO_BOOKMARK5, 	CmEditGotoRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITGO_BOOKMARK6, 	CmEditGotoRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITGO_BOOKMARK7, 	CmEditGotoRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITGO_BOOKMARK8, 	CmEditGotoRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITGO_BOOKMARK9, 	CmEditGotoRandBookmark),

	EV_COMMAND_AND_ID(CM_EDITTOGGLE_BOOKMARK0, CmEditToggleRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITTOGGLE_BOOKMARK1, CmEditToggleRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITTOGGLE_BOOKMARK2, CmEditToggleRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITTOGGLE_BOOKMARK3, CmEditToggleRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITTOGGLE_BOOKMARK4, CmEditToggleRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITTOGGLE_BOOKMARK5, CmEditToggleRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITTOGGLE_BOOKMARK6, CmEditToggleRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITTOGGLE_BOOKMARK7, CmEditToggleRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITTOGGLE_BOOKMARK8, CmEditToggleRandBookmark),
	EV_COMMAND_AND_ID(CM_EDITTOGGLE_BOOKMARK9, CmEditToggleRandBookmark),
	EV_COMMAND(IDC_OPT_SETFONT, CmOptSetfont),
	EV_COMMAND(IDC_OPT_SETCOLORS, CmOptSetcolors),
	EV_COMMAND(CM_EDITVIEWSELECTION, CmEditViewselection),
	EV_COMMAND_ENABLE(CM_EDITVIEWSELECTION, CeEditViewselection),
	EV_COMMAND(CM_EDITSMARTCURSOR, CmEditSmartcursor),
	EV_COMMAND_ENABLE(CM_EDITSMARTCURSOR, CeEditSmartcursor),
	EV_COMMAND(CM_EDITWHITESPACE, CmEditWhitespace),
	EV_COMMAND_ENABLE(CM_EDITWHITESPACE, CeEditWhitespace),
	EV_COMMAND(CM_EDITVIEWCARET, CmEditViewcaret),
	EV_COMMAND_ENABLE(CM_EDITVIEWCARET, CeEditViewcaret),
	EV_COMMAND_ENABLE(CM_EDIT_SELSTREAM, CeEditSelstream),
	EV_COMMAND(CM_EDITSELLINE, CmEditSelline),
	EV_COMMAND_ENABLE(CM_EDITSELLINE, CeEditSelline),
	EV_COMMAND(CM_EDITSELCOLUMN, CmEditSelcolumn),
	EV_COMMAND_ENABLE(CM_EDITSELCOLUMN, CeEditSelcolumn),
	EV_COMMAND_ENABLE(ID_LINEINDICATOR, CeLineindicator),
	EV_COMMAND_ENABLE(ID_DIRTYINDICATOR,CeDirtyIndicator),
//{{TsdidvViewRSP_TBL_END}}
END_RESPONSE_TABLE;


//--------------------------------------------------------
// TsdidvView
// ~~~~~~~~~~
// Construction/Destruction handling.
//
TsdidvView::TsdidvView(TDocument& doc, TWindow* parent)
:
  TCoolEditView(doc, parent)
{
	Attr.AccelTable = IDA_EDITVIEW;
  ModifyExStyle(0,WS_EX_CLIENTEDGE);
	SetViewMenu(new TMenuDescr(IDM_EDITVIEW));

	TDocTemplate* tpl = doc.GetTemplate();
	TParserCreator creator = GetCoolParserCreator(tpl);
	SetSyntaxParser(creator(this));
}
//
TsdidvView::~TsdidvView()
{
	//Destroy();
}
//
TCoolTextBuffer* 
TsdidvView::GetBuffer()
{
	return &((TCoolDocument&)GetDocument()).GetTextBuffer();
}
//
//
// Paint routine for Window, Printer, and PrintPreview for a TEditView client.
//
void TsdidvView::Paint(TDC& dc, bool erase, TRect& rect)
{
  TsdidvAppl* theApp = TYPESAFE_DOWNCAST(GetApplication(), TsdidvAppl);
  if (theApp){
    // Only paint if we're printing and we have something to paint, otherwise do nothing.
    //
    if (theApp->Printing && theApp->Printer && !rect.IsEmpty()){
      // Use pageSize to get the size of the window to render into.  For a Window it's the client area,
      // for a printer it's the printer DC dimensions and for print preview it's the layout window.
      TSize   pageSize(rect.right - rect.left, rect.bottom - rect.top);

      HFONT   hFont = (HFONT)GetWindowFont();
      TFont   font(_T("Arial"), -12);
      if (!hFont)
        dc.SelectObject(font);
      else
        dc.SelectObject(TFont(hFont));

      TEXTMETRIC  tm;
      int fHeight = dc.GetTextMetrics(tm) ? tm.tmHeight + tm.tmExternalLeading : 10;

      // How many lines of this font can we fit on a page.
      //
      int linesPerPage = MulDiv(pageSize.cy, 1, fHeight);
      if (linesPerPage){
        TPrintDialog::TData& printerData = theApp->Printer->GetSetup();

        int maxPg = ((GetNumLines() / linesPerPage) + 1.0);

        // Compute the number of pages to print.
        //
        printerData.MinPage = 1;
        printerData.MaxPage = maxPg;

        // Do the text stuff:
        //
        int   fromPage = printerData.FromPage == -1 ? 1 : printerData.FromPage;
        int   toPage = printerData.ToPage == -1 ? 1 : printerData.ToPage;
        int   currentPage = fromPage;
        TAPointer<_TCHAR> buffer = new _TCHAR[255];

        while (currentPage <= toPage) {
          int startLine = (currentPage - 1) * linesPerPage;
          int lineIdx = 0;
          while (lineIdx < linesPerPage) {
            // If the string is no longer valid then there's nothing more to display.
            //
            if (!GetLine(buffer, 255, startLine + lineIdx))
              break;
            dc.TabbedTextOut(TPoint(0, lineIdx * fHeight), buffer, strlen(buffer), 0, 0, 0);
            lineIdx++;
          }
          currentPage++;
        }
      }
			return;
    }
  }
	TCoolEditView::Paint(dc, erase, rect);
}
//
void TsdidvView::EvGetMinMaxInfo(MINMAXINFO far& minmaxinfo)
{
  TsdidvAppl* theApp = TYPESAFE_DOWNCAST(GetApplication(), TsdidvAppl);
  if (theApp) {
    if (theApp->Printing) {
      minmaxinfo.ptMaxSize = TPoint(32000, 32000);
      minmaxinfo.ptMaxTrackSize = TPoint(32000, 32000);
      return;
    }
  }
  TCoolEditView::EvGetMinMaxInfo(minmaxinfo);
}
//
//
void TsdidvView::CmEditClearBookmarks ()
{	
	ClearBookmarks();
}
//
void TsdidvView::CmEditToggleBookmark ()
{	
	ToggleRandBookmark();
}
//
void TsdidvView::CmEditGotoNextBookmark ()
{	
	NextRandBookmark();
}
//
void TsdidvView::CmEditGotoPrevBookmark ()
{	
	PrevRandBookmark();
}
//
void TsdidvView::CmEditClearAllBookmarks ()
{	
	ClearRandBookmarks();
}
//
void TsdidvView::CmEditReadonly ()
{	
	EnableReadOnly(!IsReadOnly());
}
//
void TsdidvView::CeEditReadonly (TCommandEnabler& tce)
{	
	tce.SetCheck(IsReadOnly());
}
//
void TsdidvView::CmEditGotoRandBookmark (uint id)
{
	int bookmarkId = id - CM_EDITGO_BOOKMARK0;
	GoBookmark(bookmarkId);
}
//
void TsdidvView::CmEditToggleRandBookmark(uint id)
{
	int bookmarkId = id - CM_EDITTOGGLE_BOOKMARK0;
	ToggleBookmark(bookmarkId);
}
//
void TsdidvView::CmOptSetfont()
{	
	TChooseFontDialog::TData FontData;
	//TFont* font = GetFont();
	//font->GetObject(FontData.LogFont);
  //FontData.Flags |= CF_INITTOLOGFONTSTRUCT;
  FontData.DC = 0;
  FontData.Flags = CF_FORCEFONTEXIST | CF_SCREENFONTS;
  FontData.Color = 0;      // Color and font dialogs use the same color
  FontData.Style = 0;
  FontData.FontType = SCREEN_FONTTYPE;
  FontData.SizeMin = 0;
  FontData.SizeMax = 0;
  if (TChooseFontDialog(this, FontData).Execute() == IDOK){
		SetFont(FontData.LogFont);
	  Invalidate();
  }
}
//
void TsdidvView::CmOptSetcolors ()
{	
	// INSERT>> Your code here.
}
//
void TsdidvView::CmEditViewselection ()
{	
	EnableShowInactiveSel(IsShowInactiveSel() ? false : true);
}
//
void TsdidvView::CeEditViewselection(TCommandEnabler& tce)
{	
	tce.SetCheck(IsShowInactiveSel());
}
//
void TsdidvView::CmEditSmartcursor ()
{	
	EnableSmartCursor(IsSmartCursor() ? false : true);
}
//
void TsdidvView::CeEditSmartcursor (TCommandEnabler& tce)
{	
	tce.SetCheck(IsSmartCursor());
}
//
void TsdidvView::CmEditWhitespace ()
{	
	EnableTabs(IsTabsVisible()? false : true);
}
//
void TsdidvView::CeEditWhitespace (TCommandEnabler& tce)
{	
	tce.SetCheck(IsTabsVisible());
}
//
void TsdidvView::CmEditViewcaret ()
{	
	EnableTabs(IsTabsVisible()? false : true);
}
//
void TsdidvView::CeEditViewcaret (TCommandEnabler& tce)
{	
	tce.SetCheck(IsTabsVisible());
}
//
void TsdidvView::CeEditSelstream (TCommandEnabler& tce)
{	
	tce.SetCheck(IsStreamSelMode());
}
//
void TsdidvView::CmEditSelline ()
{	
	SetSelMode(stLineSelection);
}
//
void TsdidvView::CeEditSelline (TCommandEnabler& tce)
{	
	tce.SetCheck(IsLineSelMode());
}
//
void TsdidvView::CmEditSelcolumn ()
{	
	SetSelMode(stColumnSelection);
}
//
void TsdidvView::CeEditSelcolumn (TCommandEnabler& tce)
{	
	tce.SetCheck(IsColumnSelMode());
}
//
void TsdidvView::CeLineindicator (TCommandEnabler& tce)
{	
	VERIFY_TEXTPOS(CursorPos);
  _TCHAR buffer[40];
  // VVV m_ptCursorPos.x + 1 ???
  wsprintf(buffer,_T ("Ln %d, Col %d"), CursorPos.row + 1, CursorPos.col + 1);
	tce.Enable(true);
	tce.SetText(buffer);
}
//
void TsdidvView::CeDirtyIndicator (TCommandEnabler& tce)
{
	VERIFY_TEXTPOS(CursorPos);
	//tce.Enable(true);
	tce.SetCheck(GetBuffer()->IsDirty()? 1 : 0);
}
//
//
